%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Module:       Chart.pro
% Author:       Plamen Sharapanov
% Date:         18.03.2006
% Description:  how to integrate MS Excel functionality with your Strawberry Prolog solutions
% 
%------------------------------------------------------------------------------
% The original code was in JS and was taken from
%	'Standard of Excellence' By Dmitry Khudorozhkov 
%	http://www.codeproject.com/com/excellence.asp
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

?-
%Start a new instance of Microsoft Excel
	ExlApp is server("Excel.Application"),
write("ExlApp: "),write(ExlApp),nl,
	ExlApp.'Visible' := 1,
	ExlApp.'DisplayAlerts' := 1,

	WorkBooks is ExlApp.'Workbooks',
	WorkBook is WorkBooks .'Add'(),
	Sheet is WorkBook.'ActiveSheet',
write("Sheet: "),write(Sheet),nl,

%put some test data
	myfill(Sheet),

	Rang is Sheet.'UsedRange',
write("Rang: "),write(Rang),nl,

% create chart:
	X is Rang.'Left' + Rang.'Width',
	Y is Rang.'Top',
	ChartObjects is Sheet.'ChartObjects',
write("ChartObjects: "),write(ChartObjects ),nl,
	ChartObject is ChartObjects.'Add'(X,Y, 350, 220),
write(ChartObject ),nl,
	Chart is ChartObject.'Chart',
write(Chart ),nl,
	Chart.'ChartType' := 96,
write("ChartType" ),nl,
	Chart.'SetSourceData'(Rang, 2),
write("SetSourceData" ),nl,

	ChartObject.'CopyPicture'(),
write("CopyPicture" ),nl,

	quit_excel(WorkBook, ExlApp), !,

%Start a new instance of Microsoft Word:
	WordApp is server("Word.Application"),
	WordApp."Visible":=true,
	ColDoc is WordApp."Documents",
	ODoc is ColDoc."Add"(),
%paste chart
	Selection is WordApp.'Selection',
	ParagraphFormat is Selection.'ParagraphFormat',
	ParagraphFormat.'Alignment' := 1,
	Selection.'Paste'(),

	%Selection.'TypeParagraph'(),

	yes_no("","Do you want to close MS WORD",?),
	%uncomment next to close without save
	ODoc.'Close'(0),
	WordApp.'Quit'().

%------------------------------
myfill(Sheet):-
	for(I, 1, 10),
	myput(Sheet, "A"+I, I+".01.2006"),
	myput(Sheet, "B"+I, I),
	myput(Sheet, "C"+I, random(100)/10),
	fail.
myfill(Sheet).

myput(Sheet, Where, Value) :-
	Cell is Sheet.'Range'(Where),
	Cell.'Value' := Value.

quit_excel(WorkBook, ExlApp):-
	yes_no("","Do you want to close MS Excel",?),
	WorkBook."Close"(0),
	ExlApp.'Quit'().
quit_excel(_,_).

