% This program is created by students
% from University of Sofia

?-
  G_TrX0:= 100,
  G_TrY0:= 50,
  G_TrX1:= 100,
  G_TrY1:= 250,
  G_TrX2:= 50,
  G_TrY2:= 50,

  G_Up:=0,
  G_Red_Green:=1,
  G_Show:=0,
  G_ShowLarge:=200,
  G_Show_Both:=0,
  G_Two_Vectors:=0,
  G_LargePixels:=1,
  G_Second_Sheet:=0,
  G_P:= -1,

  array(x, 24, 0.0),
  array(y, 24, 0.0),
  array(c, 21, 0.0),
% c: 0,1,2 - RGB
%        3 - Brightness
%      4,5 - Vectors L,R
%        6 - Normalization
%        7 - Transparency
%        8 - Centre Y

  ListX= [  0, 450,   0, 200],
  ListY= [100, -50, 140, 100],
  ListX2=[  0, 202,   0, 200],
  ListY2=[100,  49, 140, 100],
  ListFixed=[ 0, 130, 260, 390],

  G_T:=12, % temp
  G_RedSlider:=0,
  G_GreenSlider:=0,
  G_BlueSlider:=0,
  G_BrightnessSlider:=48,
  G_TransparencySlider:=40,
  c(G_T+4):=0-pi/4, c(G_T+5):=pi/4, c(G_T+7):=0.5,
  init(x, G_T,   ListX2),    init(y, G_T,   ListY2),
  init(x, G_T+4, ListX),     init(y, G_T+4, ListY),
  init(x, G_T+8, ListFixed), init(y, G_T+8, ListY),
  calc_centre,
  calc_color(no),

  G_T:=0,
  G_RedSlider:=33,
  G_GreenSlider:=66,
  G_BlueSlider:=100,
  G_BrightnessSlider:=50,
  G_TransparencySlider:=50,
  c(4):=0, c(5):=pi/4, c(7):=0.5,
  init(x, 0, ListX),     init(y, 0, ListY),
  init(x, 4, ListX2),    init(y, 4, ListY2),
  init(x, 8, ListFixed), init(y, 8, ListY2),
  calc_centre,
  calc_color(no),

  G_WinSupport:= window( title("Digital TV"), class(support_func),                     pos(100, 30),  size(610,860) ),
  G_WinTools:=   window( title("Tools"),      class(tools_func), parent(G_WinSupport), pos(700, 450), size(310,440) ),
  G_WinShow:=    window( title("Show"),       class(win_func),   parent(G_WinSupport), pos(700, 30),  size(310,340), not(clean_before_paint) ).

calc_cubic_root(Sin, Cos, Point, I, J, Distance):-
    X0 is Cos*x(Point) + Sin*y(Point),
    X1 is Cos*x(1+Point) + Sin*y(1+Point),
    X2 is Cos*x(2+Point) + Sin*y(2+Point),
    X3 is Cos*x(3+Point) + Sin*y(3+Point),
    Ir is Cos*I + Sin*J,
    Jr is Cos*J - Sin*I,
    A is -1*X0+3*X1-3*X2+X3,
    B is  3*X0-6*X1+3*X2,
    C is -3*X0+3*X1,
    D is    X0-Ir,
    %Discrim is 18*A*B*C*D - 4*B**3*D + B**2*C**2 - 4*A*C**3 - 27*A**2*D**2,
    Dis0 is B**2 - 3*A*C,
    Dis1 is 2*B**3 - 9*A*B*C + 27*A**2*D,
    Dis is (Dis1**2 - 4*Dis0**3),
    (Dis > 0 ->
      Temp1 is (Dis1+sqrt(Dis))/2,
      Temp2 is (Dis1-sqrt(Dis))/2,
      Temp is (abs(Temp1)>abs(Temp2)-> Temp1 else Temp2),
      Const is (Temp>0-> Temp**(1/3) else -1*(-1*Temp)**(1/3)),
      %Const is ((Dis1+sqrt(Dis2))/2)**(0.333),
      (Const=:=0.0-> write([Const, Dis0, Dis1, Dis, Temp]), nl),
      T  is (B+Const+Dis0/Const)/(-3*A),
      Y is fy(T, Sin, Cos, Point)
    else
      R0 is sqrt((Dis1**2-Dis)/4),
      R  is R0**(1/3),
      Fi is arccos(Dis1/(2*R0))/3,
      Ta is (B+cos(Fi)       *(R+Dis0/R))/(-3*A),
      Tb is (B+cos(Fi+2*pi/3)*(R+Dis0/R))/(-3*A),
      Tc is (B+cos(Fi+4*pi/3)*(R+Dis0/R))/(-3*A),
      Ya is Jr-fy(Ta, Sin, Cos, Point),
      Yb is Jr-fy(Tb, Sin, Cos, Point),
      Yc is Jr-fy(Tc, Sin, Cos, Point),
      Ya1 is (Ta>=0, Ta=<1 -> abs(Ya) else abs(Ya)+1000),
      Yb1 is (Tb>=0, Tb=<1 -> abs(Yb) else abs(Yb)+1000),
      Yc1 is (Tc>=0, Tc=<1 -> abs(Yc) else abs(Yc)+1000)
    ),
    %(I=0, J=200, Dis =< 0-> write([Point, Ya, Yb, Yc])),
    (Dis > 0 ->
      Distance is Jr-Y
    else
      Distance is (Ya1<Yb1, Ya1<Yc1 -> Ya else (Yb1<Yc1-> Yb else Yc))
    ).

calc_pixel(I, J, Color):-
  Sin1 is sin(c(4+G_T)),
  Cos1 is cos(c(4+G_T)),
  %(I=100, J=100-> write([Sin1, Cos1]), nl),
  (G_Two_Vectors=0->
    calc_pixel2(I, J, Sin1, Cos1, Color)
  else
    Sin2 is sin(c(5+G_T)),
    Cos2 is cos(c(5+G_T)),
    A is I-100,
    B is J-c(8+G_T),
    D1 is A*Cos1+B*Sin1,
    D2 is A*Cos2+B*Sin2,
    (D1<0->
      (D2<0->
        calc_pixel2(I, J, Sin1, Cos1, Color)
      else
        R is sqrt(A**2+B**2),
        Sin is A/R,
        Cos is -1*B/R,
        calc_pixel2(I, J, Sin, Cos, Color)
        %Color is rgb(0,255,0)
      )
    else
      (D2<0->
        R is sqrt(A**2+B**2),
        Sin is -1*A/R,
        Cos is B/R,
        calc_pixel2(I, J, Sin, Cos, Color)
      else
        calc_pixel2(I, J, Sin2, Cos2, Color)
      )
    )
  ).

calc_pixel2(I, J, Sin, Cos, Color):-
  Point is G_T,
  Point2 is 4+G_T,
  calc_cubic_root(Sin, Cos, Point, I, J, Distance),
  calc_cubic_root(Sin, Cos, Point2, I, J, Distance2),
  %(I=0, J=200-> write([Distance, Distance2]), nl),
  (Distance<0, G_Up=0->
    Color is rgb(255*c(G_T+3),255*c(G_T+3),0)
  else
    (Distance=:=Distance2->
      Distance3 is 255-fy2(10**10)
    else
      Distance3 is 255-fy2(Distance/abs(Distance-Distance2))
    ),
    (G_Red_Green=0->
      Brightness := c(G_T+3)*Distance3*c(G_T+6)/255,
      Color is rgb(Brightness*c(G_T), Brightness*c(G_T+1), Brightness*c(G_T+2))
    else
      ColorChange := Distance3/1000,
      Cr := c(G_T)-ColorChange,
      (Cr<0 -> Cr := 0),
      Cg := c(G_T+1)+ColorChange,
      (Cg<0 -> Cg := 0),
      Cb := c(G_T+2),
      Normalization:=c(G_T+3)*255/max(Cr, max(Cg, Cb)),
      Color is rgb(Normalization*Cr, Normalization*Cg, Normalization*Cb)
    )
  ). 

win_func(paint):-
  pen(0,0),
  brush(system_color(window)),
  rect(0,0,2*G_TrX2+200,G_TrY2),
  rect(0,0,G_TrX2,2*G_TrY2+G_ShowLarge),
  rect(0,G_TrY2+G_ShowLarge,2*G_TrX2+200,2*G_TrY2+G_ShowLarge),
  rect(G_TrX2+200,0,2*G_TrX2+200,2*G_TrY2+G_ShowLarge),
  fail.
win_func(paint):-
  for(I, 0, 200, step(G_LargePixels)),
    for(J, 0, G_ShowLarge, step(G_LargePixels)),
      calc_pixel(I, J, Color1),
      (G_Show_Both=0->
        Color is Color1
      else
        G_T:=12-G_T,
        calc_pixel(I, J, Color2),
        G_T:=12-G_T,
        rgb(Color1, R1, G1, B1),
        rgb(Color2, R2, G2, B2),
        Tr2 is 1-c(7+G_T), % or c(7+12-G_T)
        Color is rgb(c(7+G_T)*R1+Tr2*R2, c(7+G_T)*G1+Tr2*G2, c(7+G_T)*B1+Tr2*B2)
      ),
      (G_LargePixels=1->
        draw_point(I+G_TrX2, J+G_TrY2, Color)
      else
        for(A, 1, G_LargePixels),
          for(B, 1, G_LargePixels),
            draw_point(I+A-1+G_TrX2, J+B-1+G_TrY2, Color)
      ),
  fail.

win_func(paint):-
  G_Show=1,
  make_boarders.

win_func(paint):-
  draw_point(100+G_TrX2, 100+G_TrY2, Color),
  rgb(Color, R, G, B),
  text_out("Centre: R="+R+", G="+G+", B="+B+"     ", pos(50,10)).

win_func(close):-
  close(G_WinSupport).


tools_func(close):-
  close(G_WinSupport).

tools_func(init):-
  G_SliderR:=slider(class(slider_R), position(100-G_RedSlider), pos(20, 160), size(40, 110), vertical, both),
  G_SliderG:=slider(class(slider_G), position(100-G_GreenSlider), pos(70, 160), size(40, 110), vertical, both),
  G_SliderB:=slider(class(slider_B), position(100-G_BlueSlider), pos(120, 160), size(40, 110), vertical, both),
  G_SliderBr:=slider(class(slider_Br), position(100-G_BrightnessSlider), pos(170, 160), size(40, 110), vertical, both),
  G_SliderTr:=slider(class(slider_Tr), position(100-G_TransparencySlider), pos(220, 160), size(40, 110), vertical, both),
  G_Ch1:=check_box(text("Continue Up"), class(check_up), pos(10,10), size(130, 20)),
  G_Ch2:=check_box(text("Red Green"), class(red_green), pos(140,10), size(140, 20), checked),
  check_box(text("Show Boarders"), class(show_boarders), pos(10,30), size(130, 20)),
  G_Ch5:=check_box(text("Second Picture"), class(second_picture), pos(140,30), size(140, 20)),
  G_Ch4:=check_box(text("Show Both"), class(show_both), pos(140,50), size(140, 20)),
  check_box(text("Show Large"), class(show_large), pos(10,50), size(130, 20)),
  G_Ch3:=check_box(text("Two Vectors"), class(two_vectors), pos(10,70), size(130, 20)),
  check_box(text("Large Pixels"), class(large_pixels), pos(10,90), size(130, 20)).

tools_func(paint):-
  pen(1,0),
  text_out("Red is "+round(100*c(G_T))+"%  ", pos(10, 280)),
  text_out("Green is "+round(100*c(G_T+1))+"%  ", pos(10, 300)),
  text_out("Blue is "+round(100*c(G_T+2))+"%  ", pos(10, 320)),
  text_out("Brightness is "+c(G_T+3)+"             ", pos(10, 340)),
  text_out("Transparency is "+round(100-100*c(G_T+7))+"%    ", pos(10, 360)),
  brush(rgb(255,0,0)),
  ellipse(30, 140, 50, 160),
  brush(rgb(0,255,0)),
  ellipse(80, 140, 100, 160),
  brush(rgb(0,0,255)),
  ellipse(130, 140, 150, 160),
  brush(rgb(255,255,255)),
  ellipse(180, 140, 200, 160),
  brush(system_color(window)),
  ellipse(230, 140, 250, 160),
  brush(rgb(c(G_T+6)*c(G_T)*c(G_T+3), c(G_T+6)*c(G_T+1)*c(G_T+3), c(G_T+6)*c(G_T+2)*c(G_T+3))),
  rect(200, 340, 240, 380),
  brush(rgb(c(G_T+6)*c(G_T), c(G_T+6)*c(G_T+1), c(G_T+6)*c(G_T+2))),
  rect(240, 340, 280, 380).

slider_R( scroll(Type, Val, NewPos) ):-
  G_RedSlider:=100-NewPos,
  calc_color(Type).
slider_G( scroll(Type, Val, NewPos) ):-
  G_GreenSlider:=100-NewPos,
  calc_color(Type).
slider_B( scroll(Type, Val, NewPos) ):-
  G_BlueSlider:=100-NewPos,
  calc_color(Type).
slider_Br( scroll(Type, Val, NewPos) ):-
  G_BrightnessSlider:=100-NewPos,
  calc_color(Type).
slider_Tr( scroll(Type, Val, NewPos) ):-
  G_TransparencySlider:=100-NewPos,
  calc_color(Type).

calc_color(Type):-
  (G_RedSlider+G_GreenSlider+G_BlueSlider=:=0->
    c(G_T):=1/3,
    c(G_T+1):=1/3,
    c(G_T+2):=1/3
  else
    c(G_T):=G_RedSlider/(G_RedSlider+G_GreenSlider+G_BlueSlider),
    c(G_T+1):=G_GreenSlider/(G_RedSlider+G_GreenSlider+G_BlueSlider),
    c(G_T+2):=G_BlueSlider/(G_RedSlider+G_GreenSlider+G_BlueSlider)
  ),
  c(G_T+6):=255/max(c(G_T), max(c(G_T+1), c(G_T+2))),
  c(G_T+3):=exp((G_BrightnessSlider-50)/20),
  c(G_T+7):=1-G_TransparencySlider/100,
  (tools_func(paint); true),
  (Type=line; Type=page; Type=thumb_moved_to->
    update_window(G_WinShow)
  ).

make_boarders:-
  for(T0, 0, 1000),
    T is T0/1000, T1 is 1-T,
    X is T1**3*x(G_T) + 3*T1**2*T*x(1+G_T) + 3*T1*T**2*x(2+G_T) + T**3*x(3+G_T),
    Y is T1**3*y(G_T) + 3*T1**2*T*y(1+G_T) + 3*T1*T**2*y(2+G_T) + T**3*y(3+G_T),
      draw_point(X+G_TrX2, Y+G_TrY2, rgb(255,0,0)),
  fail.
make_boarders:-
  for(T0, 0, 1000),
    T is T0/1000, T1 is 1-T,
    X is T1**3*x(4+G_T) + 3*T1**2*T*x(5+G_T) + 3*T1*T**2*x(6+G_T) + T**3*x(7+G_T),
    Y is T1**3*y(4+G_T) + 3*T1**2*T*y(5+G_T) + 3*T1*T**2*y(6+G_T) + T**3*y(7+G_T),
      draw_point(X+G_TrX2, Y+G_TrY2, rgb(0,0,255)),
  fail.
make_boarders:-
  G_Two_Vectors=1,
  pen(1, rgb(0, 255, 0)),
  for(I, 0, 1),
    X is cos(c(4+I+G_T)+pi/2),
    Y is sin(c(4+I+G_T)+pi/2),
    line(100-100*X+G_TrX2, c(8+G_T)-100*Y+G_TrY2, 100+100*X+G_TrX2, c(8+G_T)+100*Y+G_TrY2),
    fail.

check_up(press):-
  set_check_box_value(_,1-get_check_box_value(_)),
  G_Up:=1-G_Up,
  update_window(G_WinSupport),
  update_window(G_WinShow).
second_sheet(press):-
  set_check_box_value(_,1-get_check_box_value(_)),
  G_Second_Sheet:=1-G_Second_Sheet,
  update_window(G_WinSupport).
two_vectors(press):-
  set_check_box_value(_,1-get_check_box_value(_)),
  G_Two_Vectors:=1-G_Two_Vectors,
  update_window(G_WinSupport),
  update_window(G_WinShow).
red_green(press):-
  set_check_box_value(_,1-get_check_box_value(_)),
  G_Red_Green:=1-G_Red_Green,
  update_window(G_WinShow).
show_boarders(press):-
  set_check_box_value(_,1-get_check_box_value(_)),
  G_Show:=1-G_Show,
  (G_Show=1->
    set_active_window(G_WinShow),
    make_boarders
  else
    update_window(G_WinShow)
  ).
large_pixels(press):-
  set_check_box_value(_,1-get_check_box_value(_)),
  G_LargePixels:=1+4-G_LargePixels, % try with 2, 3, 4, 5
  update_window(G_WinShow).
show_both(press):-
  set_check_box_value(_,1-get_check_box_value(_)),
  G_Show_Both:=1-G_Show_Both,
  update_window(G_WinShow).
second_picture(press):-
  set_check_box_value(_,1-get_check_box_value(_)),
  G_T:=12-G_T,
  make_second_picture.
make_second_picture:-
  G_RedSlider:=100*c(G_T),
  G_GreenSlider:=100*c(G_T+1),
  G_BlueSlider:=100*c(G_T+2),
  G_BrightnessSlider:=50+20*log(c(G_T+3)),
  G_TransparencySlider:=100-100*c(G_T+7),
  set_slider_pos(G_SliderR, 100-G_RedSlider),
  set_slider_pos(G_SliderG, 100-G_GreenSlider),
  set_slider_pos(G_SliderB, 100-G_BlueSlider),
  set_slider_pos(G_SliderBr, 100-G_BrightnessSlider),
  set_slider_pos(G_SliderTr, 100-G_TransparencySlider),
  calc_color(line),
  update_window(G_WinSupport).
show_large(press):-
  set_check_box_value(_,1-get_check_box_value(_)),
  G_ShowLarge:=500-G_ShowLarge,
  set_size(G_WinShow, 300, 120+G_ShowLarge),
  update_window(G_WinShow).

file_open(press) :-
  F is select_file(o, _, "TV Files (*.tv)\0*.tv\0All Files (*.*)\0*.*\0"),
  H is open(F, "rb"),
  read_pic(H),
  close(H),
  update_window(_).

read_pic(H):-
  get(H, int8)=:=1, % version
  Flags is get(H, int8),
  G_Up:=Flags/\1,
  G_Red_Green:=(Flags/\2)//2,
  G_Two_Vectors:=(Flags/\4)//4,
  G_Show_Both:=(Flags/\8)//8,
  G_T:=12*((Flags/\16)//16),
  set_check_box_value(G_Ch1, G_Up),
  set_check_box_value(G_Ch2, G_Red_Green),
  set_check_box_value(G_Ch3, G_Two_Vectors),
  set_check_box_value(G_Ch4, G_Show_Both),
  set_check_box_value(G_Ch5, (Flags/\16)//16),
  load_array(H, x, 24),
  load_array(H, y, 24),
  load_array(H, c, 21),
  set_active_window(G_WinTools),
  make_second_picture.
  
load_array(H, Ar, Num):-
  for(I, 0, Num-1),
    Ar(I):=get(H, float32),
  fail.
load_array(H, Ar, Num).

file_save(press) :- %trace,
  %F is select_file(s, _, "TV Files (*.tv)\0*.tv\0All Files (*.*)\0*.*\0"),
  F is this_program_path+"\\m.tv",
  H is open(F, "wb"),
  save_pic(H),
  close(H).

save_pic(H) :-
  put(1, H, int8), % version
  Flags is G_Up+2*G_Red_Green+4*G_Two_Vectors+8*G_Show_Both+16*true_value(G_T=\=0),
  put(Flags, H, int8),
  save_array(H, x, 24),
  save_array(H, y, 24),
  save_array(H, c, 21).

save_array(H, Ar, Num):-
  for(I, 0, Num-1),
    put(Ar(I), H, float32),
  fail.
save_array(H, Ar, Num).

support_func(init):-
  menu( normal, action(file_open), text("&Open") ),
  menu( normal, action(file_save), text("Save &As") ),
  check_box(text("Second Sheet"), class(second_sheet), pos(400, 520+G_TrY1), size(130, 20)).

support_func(paint):-
  brush(rgb(255,255,255)),
  pen(1, rgb(0,0,0)),
  line(0,G_TrY1, 600, G_TrY1),
  line(0,256+G_TrY1, 600, 256+G_TrY1),
  line(0,512+G_TrY1, 600, 512+G_TrY1),
  G_Second_Sheet=0,
  pen(3, rgb(255,0,0)),
  bezier_line(x(G_T)+G_TrX0, y(G_T)+G_TrY0, x(1+G_T)+G_TrX0, y(1+G_T)+G_TrY0, x(2+G_T)+G_TrX0, y(2+G_T)+G_TrY0, x(3+G_T)+G_TrX0, y(3+G_T)+G_TrY0),
  for(P, 0, 3),
    ellipse(x(P+G_T)+G_TrX0-10, y(P+G_T)+G_TrY0-10, x(P+G_T)+G_TrX0+10, y(P+G_T)+G_TrY0+10),
  fail.
support_func(paint):-
  G_Second_Sheet=1,
  pen(3, rgb(0,0,0)),
  for(I, 0, G_Two_Vectors),
    X is cos(c(4+I+G_T)+pi/2),
    Y is sin(c(4+I+G_T)+pi/2),
    ellipse(150+I*280+90*X-10, 120+90*Y-10, 150+I*280+90*X+10, 120+90*Y+10),
    line(150+I*280+70*X-5*Y, 120+70*Y+5*X, 150+I*280+80*X, 120+80*Y, 150+I*280+70*X+5*Y, 120+70*Y-5*X),
    line(150+I*280, 120, 150+I*280+80*X, 120+80*Y),
    ellipse(150+I*280-5, 120-5, 150+I*280+5, 120+5),
  fail.
support_func(paint):-
  G_Second_Sheet=0,
  pen(3, rgb(0,0,255)),
  bezier_line(x(4+G_T)+G_TrX1, y(4+G_T)+G_TrY1, x(5+G_T)+G_TrX1, y(5+G_T)+G_TrY1, x(6+G_T)+G_TrX1, y(6+G_T)+G_TrY1, x(7+G_T)+G_TrX1, y(7+G_T)+G_TrY1),
  for(P, 4, 7),
    ellipse(x(P+G_T)+G_TrX1-10, y(P+G_T)+G_TrY1-10, x(P+G_T)+G_TrX1+10, y(P+G_T)+G_TrY1+10),
  fail.
support_func(paint):-
  G_Second_Sheet=1,
  text_out(-1*y(8+G_T)+3*y(9+G_T)-3*y(10+G_T)+y(11+G_T), pos(20, 520+G_TrY1)),
  pen(3, rgb(0,127,0)),
  bezier_line(x(8+G_T)+G_TrX1, y(8+G_T)+G_TrY1, x(9+G_T)+G_TrX1, y(9+G_T)+G_TrY1, x(10+G_T)+G_TrX1, y(10+G_T)+G_TrY1, x(11+G_T)+G_TrX1, y(11+G_T)+G_TrY1),
  for(P, 8, 11),
    ellipse(x(P+G_T)+G_TrX1-10, y(P+G_T)+G_TrY1-10, x(P+G_T)+G_TrX1+10, y(P+G_T)+G_TrY1+10),
  fail.
support_func(paint):-
  G_Second_Sheet=1,
  for(T0, 1000, 2000),
    T is T0/1000, T1 is 1-T,
    X is T1**3*x(8+G_T)+3*T1**2*T*x(9+G_T)+3*T1*T**2*x(10+G_T)+T**3*x(11+G_T),
    Y is T1**3*y(8+G_T)+3*T1**2*T*y(9+G_T)+3*T1*T**2*y(10+G_T)+T**3*y(11+G_T),
      draw_point(X+G_TrX1, Y+G_TrY1, rgb(0,0,255)),
  fail.
support_func(paint):-
  G_Up=1,
  G_Second_Sheet=1,
  for(T0, -1000, 0),
    T is T0/1000, T1 is 1-T,
    X is T1**3*x(8+G_T)+3*T1**2*T*x(9+G_T)+3*T1*T**2*x(10+G_T)+T**3*x(11+G_T),
    Y is T1**3*y(8+G_T)+3*T1**2*T*y(9+G_T)+3*T1*T**2*y(10+G_T)+T**3*y(11+G_T),
      draw_point(X+G_TrX1, Y+G_TrY1, rgb(255,0,0)),
  fail.
support_func(paint):-
  G_Second_Sheet=1,
  Start is (G_Up=1-> -200 else 0),
  for(T0, Start, 800),
    T is T0/400, T1 is 1-T,
    Y is T1**3*y(8+G_T)+3*T1**2*T*y(9+G_T)+3*T1*T**2*y(10+G_T)+T**3*y(11+G_T),
      draw_point(T0+G_TrX1, Y+G_TrY1+256, (T0<0; T0>400-> rgb(255,0,0) else rgb(0,0,255))),
  fail.

support_func(mouse_click(X, Y)):- 
  G_Second_Sheet=0,
  for(P, 0, 3),
    (x(P+G_T)+G_TrX0-X)**2+(y(P+G_T)+G_TrY0-Y)**2<100,
  G_P:=P.
support_func(mouse_click(X, Y)):- 
  for(P, 4, 7),
    (x(P+4*G_Second_Sheet+G_T)+G_TrX1-X)**2+(y(P+4*G_Second_Sheet+G_T)+G_TrY1-Y)**2<100,
  G_P:=P+4*G_Second_Sheet.
support_func(mouse_click(X, Y)):- 
  for(I, 0, G_Two_Vectors),
    A is cos(c(4+I+G_T)+pi/2),
    B is sin(c(4+I+G_T)+pi/2),
    (150+I*280+90*A-X)**2+(120+90*B-Y)**2<100,
    G_P:= -3+I.

support_func(mouse_click_up(X, Y)):-
  G_P =\= -1,
  (G_P>=0, G_P=<4->
    calc_centre
  ),
  update_window(G_WinShow),
  G_P:= -1.

support_func(mouse_move(X, Y)):- 
  G_P< -1,
  I is G_P+3,
  c(4+I+G_T):=arccos((X-150-I*280)/sqrt((X-150-I*280)**2+(Y-120)**2))-pi/2,
  (Y<120-> c(4+I+G_T):=pi-c(4+I+G_T)),
  update_window(_).
support_func(mouse_move(X, Y)):- 
  G_P> -1,
  (G_P>3-> TrX is G_TrX1, TrY is G_TrY1 else TrX is G_TrX0, TrY is G_TrY0),
  y(G_P+G_T):=Y-TrY,
  (not(G_P mod 4=:=0; G_P mod 4=:=3; G_P>8)->
    x(G_P+G_T):=X-TrX
  ),
  update_window(_).

calc_centre:-
  calc_cubic_root(0, 1, G_T, 100, 100, Distance),
  c(8+G_T) := 100-Distance.

Y is fy(T, Sin, Cos, P):-
  T1 is 1-T,
  Y := T1**3*(Cos*y(P)-Sin*x(P)) + 3*T1**2*T*(Cos*y(1+P)-Sin*x(1+P)) + 3*T1*T**2*(Cos*y(2+P)-Sin*x(2+P)) + T**3*(Cos*y(3+P)-Sin*x(3+P)).

Y is fy2(T):-
  T1 is 1-T,
  Y := T1**3*y(8+G_T) + 3*T1**2*T*y(9+G_T) + 3*T1*T**2*y(10+G_T) + T**3*y(11+G_T).

init(Array, From, [H|T]):-
  Array(From):=H,
  From2 is From+1,
  init(Array, From2, T).
init(_, _, []).

