?-
  Level=1,
  G_FindX:= (random(1000)- 500)*Level,
  G_FindY:= (random(1000)- 500)*Level,
  pen(0,0),
  G_PosX:= 0.0,
  G_PosY:= 0.0,
  G_Zoom:= 2.5,
  G_ScrollRange := 1000,
  G_Find:= 0,
  G_moveX:= -100,
  window(title("Fractals - find the target"), size(502,540),h_scroll,v_scroll).

win_func(init):-
  menu(normal, action(show_target), text("&Show Target") ),
  menu(right, action(menu_zoom_in), text("Zoom &In") ),
  menu(right, action(menu_zoom_out), text("Zoom &Out") ),
  menu( right, action(menu_help), text("&Help") ),
  set_scroll_range(_,vertical,0,G_ScrollRange),
  set_scroll_range(_,horizontal,0,G_ScrollRange),
  fix_scroll_bars.

win_func(size(X,Y)):-
  G_Xsize:=X,
  G_Ysize:=Y,
  (G_Find>1->
    G_Zoom:= max(G_Xsize,G_Ysize)/200,
    update_window(_)
  ).

win_func(key_down(Char, Rep)):-
  check,
  (Char=12; Char=101; Char=53-> % 5
    show_place,
    update_window(_),
    fail
  ),
  Xold:=G_PosX,
  Yold:=G_PosY,
  (Char=37; Char=36; Char=35-> % left
    G_PosX:= G_PosX - G_Xsize*0.02*Rep/G_Zoom
  ),
  (Char=39; Char=34; Char=33-> % right
    G_PosX:= G_PosX + G_Xsize*0.02*Rep/G_Zoom
  ),
  (Char=38; Char=36; Char=33-> % up
    G_PosY:= G_PosY - G_Ysize*0.02*Rep/G_Zoom
  ),
  (Char=40; Char=34; Char=35-> % down
    G_PosY:= G_PosY + G_Ysize*0.02*Rep/G_Zoom
  ),
  move(Xold, Yold).

win_func(mouse_click(X, Y)):-
  check,
  G_moveX:=X,
  G_moveY:=Y,
  set_capture(_).

win_func(mouse_click_up(X, Y)):-
  release_capture.

win_func(mouse_move(X, Y)):-
  (message_flags(left)->
    check,
    Xold:=G_PosX,
    Yold:=G_PosY,
    G_PosX:= G_PosX + (G_moveX-X)/G_Zoom,
    G_PosY:= G_PosY + (G_moveY-Y)/G_Zoom,
    move(Xold, Yold),
    G_moveX:=X,
    G_moveY:=Y
  ).

win_func(scroll(Direction,Type,Val)):-
  check,
  Xold:=G_PosX,
  Yold:=G_PosY,
  (Type=line->
    Step := 0.02
  else (Type=page->
    Step := 0.3
  else (Type=thumb_track->
    Step := 0.02,
    Old := Val,
    Val := Val - G_Scroll,
    G_Scroll := Old
  else % thumb_moved_to
    G_Scroll := (G_ScrollRange-G_ScrollPage)//2,
    fail
  ))),
  (Direction=horizontal-> % left / right
    G_PosX:= G_PosX + G_Xsize*Step*Val/G_Zoom
  else (Direction=vertical-> % up / down
    G_PosY:= G_PosY + G_Ysize*Step*Val/G_Zoom
  )),
  move(Xold, Yold).

win_func(mouse_wheel(Delta, X, Y)):-
  check,
  (message_flags(left); message_flags(ctrl)->
    client_pos(_,A,B),
    zoom(0-Delta, X-A, Y-B)
  else
    Yold:=G_PosY,
    G_PosY:= G_PosY - 3*G_Ysize*0.02*Delta/G_Zoom,
    move(G_PosX, Yold)
  ).

win_func(r_mouse_click(X, Y)):-
  check,
  (message_flags(ctrl)->
    zoom( 1, X, Y)
  else
    zoom(-1, X, Y)
  ). 

win_func(paint):-
  G_Zoom>0.02,
  get_paint_rect(A,B,C,D),
  X1 is floor((G_PosX+A/G_Zoom - 50)/100),
  X2 is floor((G_PosX+C/G_Zoom)/100),
  Y1 is floor((G_PosY+B/G_Zoom - 50)/100),
  Y2 is floor((G_PosY+D/G_Zoom)/100),
  for(J,Y1,Y2),
    for(I,X1,X2),
      X is floor(I*100*G_Zoom)-floor(G_PosX*G_Zoom),
      Y is floor(J*100*G_Zoom)-floor(G_PosY*G_Zoom),
      Size is floor(150*G_Zoom),
      is_rect_in_paint(X,Y,X+Size,Y+Size),
      Abs is abs(I) + abs(J),
      start_random_from(true_value(I>0)+ 2*true_value(J>0) 
       + 4* ((1+Abs)*Abs//2+abs(I))),

      for(_, 0,random(8)+16*random(1)),
        Elx is  X+floor(random(100)*G_Zoom),
        Ely is  Y+floor(random(100)*G_Zoom),
        Elr is  floor((5 +random(20))*G_Zoom),
        brush(rgb(random(255), random(255), random(255))), % Win XP/NT
        Fig is random(5),
        Add=floor(random(50)*G_Zoom), % Add is term!
        (Fig=0->
          ellipse(Elx,Ely,Elx+Elr,Ely+Elr)
        else (Fig=1->
          rect(Elx,Ely,Elx+Elr,Ely+Elr)
        else (Fig=2->
          fill_polygon(Elx+Add,Ely+Add,Elx+Add,Ely+Add,Elx+Add,Ely+Add)
        else (Fig=3->
          fill_polygon(Elx+Add,Ely+Add,Elx+Add,Ely+Add,Elx+Add,Ely+Add,Elx+Add,Ely+Add)
        else
          fill_polygon(Elx+Add,Ely+Add,Elx+Add,Ely+Add,Elx+Add,Ely+Add,Elx+Add,Ely+Add,Elx+Add,Ely+Add)
        )))),
      fail.

move(Xold, Yold):-
  scroll_window(_, floor(Xold*G_Zoom)-floor(G_PosX*G_Zoom), floor(Yold*G_Zoom)-floor(G_PosY*G_Zoom), 1).

zoom(Delta, X, Y):-
  G_Zoom:=G_Zoom*0.9**Delta,
  G_PosX:= G_PosX - X* (1 - 0.9**Delta)/G_Zoom,
  G_PosY:= G_PosY - Y* (1 - 0.9**Delta)/G_Zoom,
  fix_scroll_bars,
  update_window(_).

fix_scroll_bars:-
  G_ScrollPage := (G_Zoom=<2.5 -> 100*G_Zoom else 150+100*log(G_Zoom)/log(2.5)),
  G_Scroll := (G_ScrollRange-G_ScrollPage)//2,
  set_scroll_page(_,vertical,G_ScrollPage),
  set_scroll_page(_,horizontal,G_ScrollPage),
  set_scroll_pos(_,vertical,G_Scroll),
  set_scroll_pos(_,horizontal,G_Scroll).

show_target(press):-
  check,
  show_place,
  update_window(_),
  fail.

menu_zoom_in(press):- client_size(_,W,H), zoom(-1, W//2, H//2).
menu_zoom_out(press):- client_size(_,W,H), zoom(1, W//2, H//2).

menu_help(press):-
  message("Fractals - find the target",
  "You are in an infinite fractal field. Your task is to find the target place.

In order to see the target use the menu or press 5. You can zoom in and out by the right mouse button (combined with the button Ctrl). You can drag the field with the mouse. Also you can move by the arrows (you have arrows even for diagonal move). Other possibility to move and zoom is by the mouse wheel.",i).

check:-
  (G_Find>1->
    (G_Find=3->
      set_text("The target has been found ! ! !", _)
    else
      set_text("Fractals - find the target", _)
    ),
    G_Find:=G_Find - 2,
    G_PosX:= G_sPosX,
    G_PosY:= G_sPosY,
    G_Zoom:= G_sZoom,
    update_window(_),
    fail
  else
  (
  G_Find=0,
  abs(1-max(G_Xsize,G_Ysize)/200/G_Zoom)<0.2,
  abs(G_PosX - G_FindX)<G_Xsize*0.05/G_Zoom,
  abs(G_PosY - G_FindY)<G_Ysize*0.05/G_Zoom->
    G_Find:=1,
    set_text("The target has been found ! ! !", _),
    message("Congratulations","This is the target.",!),
    fail
  )).

show_place:-
  set_text("The target", _),
  G_sPosX:= G_PosX,
  G_sPosY:= G_PosY,
  G_sZoom:= G_Zoom,
  G_Find:=G_Find + 2,
  G_PosX:= G_FindX,
  G_PosY:= G_FindY,
  G_Zoom:= max(G_Xsize,G_Ysize)/200.
