R is max_speed :- R:=500.0.  % 500 cm/ds = 50 m/s = 180 km/h
R is wait_time :- R:=100. % 10 seconds = 100 deciseconds (ds)
R is plus_minus :- R:=50. % 5 seconds
R is unexpected_delay_size :- R:=1000.
R is unexpected_delay_freq :- R:=20.
R is max_wagons :- R:=400.
R is wagon_size :- R:=2000.
R is end_map :- R:= finish_station_pos(1)-500000.


initialisation:-
  G_Start_from_the_beginning := 0,
  G_Try_the_standard_scheme := 0,
  G_Pause := 0,
  G_FastSpeed := 1,
  G_More_Info := 0,
  G_More_Info2 := 0,
  G_Accident := 0,
  G_Unexpected_Delay := 0,
  G_Energy_Saving := 1,
  G_Crazy_Speed := 1, % 2 for crazy speed, 1 for careful stop
  G_Run_Invisible := 0,
  G_ExtraDistance := 1800,

  max_wagons>=G_Wagons_in_use,
  G_New_Map_Number := G_Map_Number,
  G_The_Wagon := 0,
  size(screen, _, H),
  G_BigSize := true_value(H>=1080),
  (G_BigSize=:=1 ->
    G_PosX := -13000.0,
    G_Zoom := 0.1
  else
    G_PosX := -10000.0,
    G_Zoom := 0.09
  ),
  G_PosX1 := 0,
  G_PosX2 := 0,
  G_PosY := -2000.0,
  G_PosSmall := 0,
  G_ScrollRange := 1000,
  G_Time := 0,
  G_WagonNum := 0,
  G_NextColor := 0,
  G_Last_Speed := G_FastSpeed,
  G_MenuNumber := 0,
  G_map_list := 1,
  G_Show_the_transfers := 0,
  G_Follow_the_wagon := 0,
  G_The_map_in_the_wagon := 0,
  G_Color_of_wagons := 0,

  G_moveX:=no,

  array(wagonX, max_wagons, -33000),
  array(wagonY, max_wagons, 1000),
  array(wPosoka, max_wagons, 1),
  array(wOldX, max_wagons, 0),
  array(wJump, max_wagons, 0),
  array(wStop, max_wagons, 0),
  array(wLine, max_wagons, 0),
  array(wSpeed, max_wagons, 0.0),
  array(wTargetSpeed, max_wagons, 0.0),
  array(wStopAt, max_wagons, 0),
  array(wAcceleration, max_wagons, 0.0), % 1 = 1 m/s2
  array(wCount, max_wagons, 0),
  array(wColor, max_wagons, rgb(0, 255, 0)),
  array(wNext, max_wagons, -1),
  array(wPrevious, max_wagons, -1),
  array(wTime, max_wagons, 0),

  array(wFlags, max_wagons, 0),
  %  1 - the next in the train (this wagon will stop together with the previous one)
  %  2 - wait the semaphore to switch
  %  4 - the door is open
  %  8 - the wagon is going to be Ready (in) or Removed 
  % 16 - with 8 {in (1) or out} without 8 {1 clean also busy AB, 0 clean only the semaphor}
  % 32 - stopping to prevent crash
  % 64 - stopping to stop
  % 0x100  - a, b, c, 0
  % 0x1000 - 1, 2, 4, 0

  array(first2, 3*8, -1),
  % Arg1: 0 Left
  %       1 not in use
  %       2 Right

  % Arg2: 0 main first
  %       1 A
  %       2 B
  %       3 A Ready
  %       4 B Ready
  %       5 A Number
  %       6 B Number
  %       7 main last
  array(semaphore, 4, 0),
  array(statistic, 4, -1),
  array(line, 3, 9),
  array(trains_await, 3, 0),
  array(busy, 3, 0),
  % 1 inside
  % 2 both
  % 4 outside
  % 0x100 - A is busy
  % 0x200 - A ready
  % 0x400 - A composing
  % 0x10 - B ...
  % 0x20 - B ...
  % 0x40 - B ...

  % old
  % 32 -> 0x100 - A for loading and emptying
  % 8  -> 0x200 - A only for loading
  % 64 -> 0x10 - B
  % 16 -> 0x20 - B

  array(arrive_line, 4, 0),
  array(wagon_arrive, 13, 0),
  array(wagon_time, 13, 0),
  _ is chronometer().

make_traffic(Traffic):-
  G_Traffic := Traffic,
  (Traffic=:=1 ->
    G_TrainSize := 4
  else (Traffic<4 ->
    G_TrainSize := 2
  else
    G_TrainSize := 1
  )),
  G_time_period := (Traffic mod 2 =:= 0 -> G_time_period_fast else integer((4/3)*G_time_period_fast)),
  (6 =< Traffic, Traffic =< 7 ->
    G_time_period := 2*G_time_period
  ),
  (Traffic=:=8 ->
    G_Stop := 1,
    trains_await(0) := 0,
    trains_await(2) := 0
  else
    G_Stop := 0
  ).

convert_brush(6, 1).
convert_brush(8, 3).
convert_brush(9, 2).

make_brush(-1):- brush(rgb(200, 200, 255)).
make_brush(0):- brush(rgb(255, 255, 255)).
make_brush(1):- brush(rgb(0, 255, 0)).
make_brush(2):- brush(rgb(0, 0, 255)).
make_brush(3):- brush(rgb(255, 255, 0)).
make_brush(4):- brush(rgb(255, 0, 0)).
make_brush(12):- brush(rgb(255, 200, 200)).
  
wagon_color(1, rgb(0, 255, 0)).
wagon_color(2, rgb(0, 0, 255)).
wagon_color(3, rgb(255, 255, 0)).
wagon_color(4, rgb(255, 0, 0)).
wagon_color(5, rgb(0, 255, 255)).
wagon_color(6, rgb(255, 255, 255)).
wagon_color(7, rgb(128, 0, 128)).
wagon_color(0, rgb(255, 0, 255)).

R is first(int X, int Y) :- R := first2(8*X+Y).
first(X, Y) ::= Val :- first2(8*X+Y) := Val.
