station_at_pos(Pos):-
  station(yes, _, Station, _, _, _),
  Pos =< Station+4000,
  Pos >= Station-4000.

visible_station(N, Station, Semaphore, Distance, big):-
  station(yes, N, Station, Semaphore, _, _),
  G_PosX =< Station+Distance,
  G_PosX+G_Xsize/G_Zoom >= Station-Distance.
visible_station(N, Station, Semaphore, Distance, small):-
  station(yes, N, Station, Semaphore, _, _),
  G_PosSmall-80000 =< Station+Distance,
  G_PosSmall+530000 >= Station-Distance.

visible_wagon(I, big):-
  G_PosX =< wagonX(I)+1000,
  G_PosX+G_Xsize/G_Zoom >= wagonX(I)-1000.
visible_wagon(I, small):-
  G_PosSmall-30000 =< wagonX(I)+1000,
  G_PosSmall+530000 >= wagonX(I)-1000.

my_paint(PosX, PosY, ZoomX, ZoomY, small):-
  pen(0, 0),
  brush(rgb(0, 180, 180)),
  rect(0, 0, G_Xsize+10, 100),
  pen(1, 0),
  X1 := (G_PosX-PosX)*ZoomX,
  X2 := (G_PosX-PosX+G_Xsize/G_Zoom)*ZoomX,
  Y1 := (G_PosY-PosY+100/G_Zoom)*ZoomY,
  Y2 := (G_PosY-PosY+G_Ysize/G_Zoom)*ZoomY,
  line(X1, Y1, X1, Y2, X2, Y2, X2, Y1, X1, Y1),
  fail.

my_paint(PosX, PosY, ZoomX, ZoomY, Variant):-
  ZoomY>=0.01,
  make_station(1, PosX, PosY, ZoomX, ZoomY, Variant).
my_paint(PosX, PosY, ZoomX, ZoomY, Variant):-
  ZoomY>=0.01,
  make_station(-1, PosX, PosY, ZoomX, ZoomY, Variant).

my_paint(PosX, PosY, ZoomX, ZoomY, Variant):-
  ZoomY>=0.02,
  (ZoomX>0.08->
    pen(1+10*ZoomX, rgb(255, 0, 0)),
    Add:=72
  else
    pen(1+2*10*ZoomX, rgb(255, 0, 0)),
    Add:=0
  ),
  get_metro_line(X1, Y1, X2, Y2, Sem1, Sem2, Variant),
  X1p := (Sem1\=no, semaphore(Sem1)=:=1 -> X1+1350 else X1),
  X2p := (Sem2\=no, semaphore(Sem2)=:=1 -> X2-1350 else X2),
  line((X1p-PosX)*ZoomX, (Y1+Add-PosY)*ZoomY, (X2p-PosX)*ZoomX, (Y2+Add-PosY)*ZoomY),
  put_grid(X2, Y2, X1, Y1, PosX, PosY, ZoomX, ZoomY, Variant),
  (ZoomX>0.08->
    line((X1p-PosX)*ZoomX, (Y1-Add-PosY)*ZoomY, (X2p-PosX)*ZoomX, (Y2-Add-PosY)*ZoomY)
  ),
  fail.

my_paint(PosX, PosY, ZoomX, ZoomY, Variant):-
  ZoomY>=0.02,
  (ZoomX>0.08->
    Add:=72
  else
    Add:=0
  ),
  metro_arc(X, Y, Sign, Q1, Q2, _, Semaphore),
  D := (Q2-Y)+(Q1-X)**2/(Q2-Y),
  % write(" R="+D/2), nl,
  (Sign*X>Sign*Q1 -> Y := Y+30, Q2 := Q2 + 10), % +10, +30 for beauty
  (Semaphore\=no, semaphore(Semaphore)=:=0 ->
    Open := (X>Q1 -> -1350 else 1350)
  else
    Open := 0
  ),
  my_draw_arc(X, Y+Add, D, Q1, Q2+Add, Open, Sign, PosX, PosY, ZoomX, ZoomY, Variant),
  (ZoomX>0.08->
    my_draw_arc(X, Y-Add, D, Q1, Q2-Add, Open, Sign, PosX, PosY, ZoomX, ZoomY, Variant)
  ),
  fail.

my_paint(PosX, PosY, ZoomX, ZoomY, Variant):-
  font(10,25,_),
  pen(10*ZoomX, 0),
  for(I, 0, G_WagonNum-1),
  visible_wagon(I, Variant),
  (G_Color_of_wagons =:= 1->
    brush(wColor(I))
  else
    Jump := wJump(find_head(I)),
    Color := (Jump>0 -> Jump else 0),
    make_brush(Color)
  ),
  X := (wagonX(I)-PosX)*ZoomX,
  Y := (wagonY(I)-PosY)*ZoomY,
  (in_curve(I, Xc, Yc, Sign, R)->
    Alfa := arccos((wagonX(I)-Xc)/R),
    Cx := (sin(Alfa)*1000-wPosoka(I)*Sign*cos(Alfa)*150)*ZoomX,
    Cy := (sin(Alfa)*150+wPosoka(I)*Sign*cos(Alfa)*1000)*ZoomY,
    Cx2 := (sin(Alfa)*1000+wPosoka(I)*Sign*cos(Alfa)*150)*ZoomX,
    Cy2 := (sin(Alfa)*150-wPosoka(I)*Sign*cos(Alfa)*1000)*ZoomY,
    fill_polygon( X - Cx, Y - Cy, X - Cx2, Y + Cy2, X + Cx, Y + Cy, X + Cx2, Y - Cy2)
  else
    SizeX := 1000*ZoomX,
    SizeY := 150*ZoomY,
    (wFlags(I)/\4=:=0->
      rect(X - SizeX, Y - SizeY, X + SizeX, Y + SizeY)
    else (wPosoka(I)=:=1->
      rect(X - SizeX, Y - SizeY, X + SizeX, Y + SizeY+120*ZoomY)
    else
      rect(X - SizeX, Y - SizeY - 120*ZoomY, X + SizeX, Y + SizeY)
    ))
  ),
  (Variant=big, ZoomX>0.08->
    make_text(G_MenuNumber, I, Text),
    text_out(Text, pos(X-25, Y-10))
  ),
  fail.

my_paint(PosX, PosY, ZoomX, ZoomY, Variant):-
  font(ZoomY*300,ZoomY*750,_),
  visible_station(N, Station, _, 8000, Variant),
  station(yes, N, Station, _, Text, Text2),
  X := Station-2000,
  Y := -500,
  text_out(N+". "+Text+" "+Text2, pos((X-PosX)*ZoomX-5, (Y-PosY)*ZoomY-10)),
  fail.

my_paint(PosX, PosY, ZoomX, ZoomY, big):-
  G_Zoom>0.08,
  font(10,25,_),
  make_map_and_list.

make_map_and_list:-
  visible_station(N, Station, _, 8000, big),
  init_wagon_arrive,
  Last := first(0, 7),
  (Last =\= -1 ->
    Last := find_head(Last),
    (find_wagon_arrive(Last, Station, 1); true)
  ),
  calc_wagon_time(Station, 1),
  calc_arrive_line(N, 1),
  draw_when(Station),
  (G_More_Info =:= 1 ->
    draw_data(Station, 0)
  ),
  pen(10*G_Zoom, 0),
  G_The_map_in_the_wagon =:= 0,
  (G_map_list=:=0 ->
    make_map(N, Station)
  else
    make_list_in_s(N, Station) % make_list(N, Station)
  ),
  fail.

make_map_and_list:-
  G_The_map_in_the_wagon =:= 1,
  client_size(_, A, B),
  Station := G_PosX + 0.55*A/G_Zoom - G_PosX2,
  PosY := 2350,
  X := Station-2000-2*wagon_size,
  map_list(G_map_list, Text),
  text_out("The "+Text+" in the wagon "+G_The_Wagon, pos((X-G_PosX-2200)*G_Zoom-5, (PosY-G_PosY+600)*G_Zoom-10)),
  (G_Follow_the_wagon =:= 1 ->
    text_out("We follow this wagon.", pos((X-G_PosX-2200)*G_Zoom-5, (PosY-G_PosY+1000)*G_Zoom-10))
  ),
  (G_More_Info =:= 1 ->
    draw_data(Station, 1)
  ),
  (G_map_list=:=0 ->
    make_map(0, Station),
    draw_stations_in_w(Station)
  else
    make_list_in_w(Station)
  ),
  fail.

make_map(N, Station):-
  PosY := 500,
  make_brush(12),
  X := Station-1500,
  Y := 2870+PosY,
  Rx := 200,
  Ry := 550,
  ellipse((X+Rx-G_PosX)*G_Zoom, (Y+Ry-G_PosY)*G_Zoom, (X-Rx-G_PosX)*G_Zoom, (Y-Ry-G_PosY)*G_Zoom),
  pen(20*G_Zoom, rgb(0, 0, 255)),
  Y0:=2500+PosY,
  Y := 3250+PosY,
  X1 := Station-5500,
  X2 := Station,
  line((X1-G_PosX)*G_Zoom, (Y0-G_PosY)*G_Zoom, (X2+500-G_PosX)*G_Zoom, (Y0-G_PosY)*G_Zoom),
  line((X1-G_PosX)*G_Zoom, (Y-G_PosY)*G_Zoom, (X2-4500-G_PosX)*G_Zoom, (Y-G_PosY)*G_Zoom),
  D:=750,
  draw_arc((X1-D/2-G_PosX)*G_Zoom, (Y0-G_PosY)*G_Zoom, (X1+D/2-G_PosX)*G_Zoom, (Y0+D-G_PosY)*G_Zoom, (X1-G_PosX)*G_Zoom, (Y0-G_PosY)*G_Zoom, (X1-G_PosX)*G_Zoom, (Y-G_PosY)*G_Zoom),
  pen(20*G_Zoom, rgb(255, 0, 0)),
  X1 := Station-4500,
  X2 := Station+4500,
  line((X1-G_PosX)*G_Zoom, (Y-G_PosY)*G_Zoom, (X2-G_PosX)*G_Zoom, (Y-G_PosY)*G_Zoom),
  pen(10*G_Zoom, 0),
  Add :=5500, Y:=2500+PosY, Sign:= -1,
  for(I, 1, 32),
    (I=:=14-> Y :=3250+PosY, Add := -7000, Sign:=1),
    R := (I=:=N -> 200 else 100),
    X := Station-4500 + Sign*I*500+Add,
    (G_The_map_in_the_wagon =:= 1 ->
      R := 70,
      Brush := -1
    else (I<N->
      Brush := -1
    else
      Brush := (N=:=I -> 0 else 1+(I-N-1) mod 10)
    )),
    more_variants(Brush, Brushes),
    Length := list_length(Brushes)-1,
    Y1:=Y-60*Length,
    R1:=R-10*Length,
    draw_ellipse(X, Y1, R1, Brushes),
    (G_Zoom>0.2->
      text_out(I, pos((X-G_PosX)*G_Zoom-5, (Y-G_PosY)*G_Zoom-10)),
      station(_, I, _, _, Text, Text2),
      text_out(Text, pos((X-150-G_PosX)*G_Zoom-5, (Y+300-G_PosY)*G_Zoom-10)),
      text_out(Text2, pos((X-150-G_PosX)*G_Zoom-5, (Y+300-G_PosY)*G_Zoom+15))
    ),
  fail.
make_map(_, _).

draw_stations_in_w(Station):-
  PosY := 500,
  Wagon := find_head(G_The_Wagon),
  wJump(Wagon) > 0,
  before_station(Wagon, N),
  Line := wLine(Wagon),
  next_stop(Line, Jump, Stop),
  P := wPosoka(Wagon),
  Start := finish_station(-1*P),
  Finish := finish_station(P),
  (P =:= 1 ->
    Add :=  5500, Y:=2500+PosY, Sign:= -1
  else
    Add := -7000, Y:=3250+PosY, Sign:= 1
  ),
  for(I, Start, Finish, step(P)),
    (P =:= 1, I=:=14 ->
      Add := -7000, Y:=3250+PosY, Sign:= 1
    else (P =:= -1, I=:=13 ->
      Add :=  5500, Y:=2500+PosY, Sign:= -1
    )),
    (I=:=N, wFlags(Wagon) /\ 4 =\= 0 ->
      Brush := 1 + Jump mod 4,
      R := 200
    else (Stop > 1 ->
      Brush := (P*I < P*N -> -1 else 0),
      R := 70
    else
      Brush := (P*I < P*N -> 12 else 1 + Jump mod 4),
      R := 130
    )),
    Stop := Stop - 1,
    (Stop < 1 ->
      Jump := 1 + Jump mod 4,
      Stop := Jump
    ),
    X := Station-4500 + Add + Sign*I*500,
    make_brush(Brush),
    ellipse((X+R-G_PosX)*G_Zoom, (Y+R-G_PosY)*G_Zoom, (X-R-G_PosX)*G_Zoom, (Y-R-G_PosY)*G_Zoom),
    (G_Zoom>0.2->
      text_out(I, pos((X-G_PosX)*G_Zoom-5, (Y-G_PosY)*G_Zoom-10))
    ),
    (I=:=Finish ->
      Jump := wJump(Wagon),
      make_brush(Jump),
      station(_, N, StationX, _, _, _),
      (previous_station(Wagon, N, Previous)->
        station(yes, Previous, StationX0, _, _, _)
      else
        StationX0 := StationX - P*15000
      ),
      Ratio := (StationX0-wagonX(Wagon))/(StationX0-StationX),
      (N < 14 ->
        Add1 :=  5500, Y1:=2500+PosY, Sign1:= -1
      else
        Add1 := -7000, Y1:=3250+PosY, Sign1:= 1
      ),
      X := Station-4500 + Add1 + Sign1*(N-P)*500 + P*Sign1*Ratio*500,
      R := 70,
      ellipse((X+R-G_PosX)*G_Zoom, (Y1+R-G_PosY)*G_Zoom, (X-R-G_PosX)*G_Zoom, (Y1-R-G_PosY)*G_Zoom)
    ),
    fail. 

make_list_in_w(Station):-
  PosY := 2950,
  R:= 100,
  X := Station-2*wagon_size,
  font(G_Zoom*90,G_Zoom*225,_),
  Wagon := find_head(G_The_Wagon),
  P := wPosoka(Wagon),
  Jump := wJump(Wagon),
  Jump > 0,
  Stop := (wStop(Wagon) =:= 0 -> 1 else wStop(Wagon)),
  before_station(Wagon, N),
  First := N+P*(Stop-1),
  FirstJump := 1 + Jump mod 4,
  Finish := finish_station(P),
  for(I, N, Finish, step(P)),
    Y2:= PosY+300*(abs(I-N) mod 10),
    station(_, I, _, _, Text, Text2),
    color_text(_, (I=:=N, wFlags(Wagon) /\ 4 =\= 0 -> rgb(255, 0, 0) else (Stop > 1 -> rgb(160, 160, 255) else rgb(0, 0, 0) )) ),
    text_out( I+". "+Text+" "+Text2, pos((X+200-G_PosX)*G_Zoom-5, (Y2-G_PosY)*G_Zoom-10)),
    (G_Show_the_transfers =:= 1, Stop > 1 ->
      color_text(_, rgb(200, 0, 0)),
      (Jump =:= wJump(Wagon), abs(I-N)<4 ->
        text_out( "at "+(I+P*(Stop-1))+" and go back", pos((X+wagon_size+200-G_PosX)*G_Zoom-5, (Y2-G_PosY)*G_Zoom-10))
      else
        Dif := 10,
        best_transfer_station(Best, Color, Dif, First, I, P, FirstJump, FirstJump),
        text_out( "at "+Best+" and take    ", pos((X+wagon_size+200-G_PosX)*G_Zoom-5, (Y2-G_PosY)*G_Zoom-10)),
        make_brush(Color),
        X2 := X + 2*wagon_size-450,
        ellipse((X2-R-G_PosX)*G_Zoom, (Y2-R-G_PosY)*G_Zoom, (X2+R-G_PosX)*G_Zoom, (Y2+R-G_PosY)*G_Zoom)
      )
    ),
    Stop := Stop - 1,
    (Stop < 1 ->
      Jump := 1 + Jump mod 4,
      Stop := Jump,
      make_brush(Jump),
      % Bug if: Jump := 1 + Jump,
      fill_polygon((X-R-G_PosX)*G_Zoom, (Y2+25+R-G_PosY)*G_Zoom, (X+R-G_PosX)*G_Zoom, (Y2+25-G_PosY)*G_Zoom, (X-R-G_PosX)*G_Zoom, (Y2+25-R-G_PosY)*G_Zoom)
    ),
    (abs(I-N) mod 10 =:= 9 -> % Column
      X := X+2*wagon_size
    ), 
    (I=:=Finish ->
      color_text(_, rgb(0, 0, 0))
    ), 
    fail.

make_list_in_s(N, Station):-
  PosY := 2950,
  R:= 100,
  X := Station-2*wagon_size,
  font(G_Zoom*90,G_Zoom*225,_),
  Finish := finish_station(1),
  for(I, N+1, Finish),
    Y:= PosY+300*((I-N-1) mod 10),
    station(_, I, _, _, Text, Text2),
    color_text(_, rgb(0, 0, 0) ),
    text_out( I+". "+Text+" "+Text2, pos((X+200-G_PosX)*G_Zoom-5, (Y-G_PosY)*G_Zoom-10)),
    first_will_come(First),
    Brush := 1+(I-N-1) mod 10,
    more_variants(Brush, Brushes),
    Length := list_length(Brushes)-1,
    X1:=X-60*Length,
    R1:=R-10*Length,
    draw_mark(X1, Y, R1, Brushes),
    Dif := 10,
    (best_transfer_station(Best, Color, Dif, N, I, 1, First, First), Best =\= N, G_Show_the_transfers =:= 1 ->
      best_dif(First, Brush, _, Dif2),
      X2 := X + wagon_size,
      color_text(_, rgb(200, 0, 0)),
      text_out( "    to "+Best+" and    ("+(Dif2-Dif)+")", pos((X2+300-G_PosX)*G_Zoom-5, (Y-G_PosY)*G_Zoom-10)),
      make_brush(First),
      X2 := X2 + 350,
      ellipse((X2-R-G_PosX)*G_Zoom, (Y+20-R-G_PosY)*G_Zoom, (X2+R-G_PosX)*G_Zoom, (Y+20+R-G_PosY)*G_Zoom),
      make_brush(Color),
      X2 := X2 + wagon_size-900,
      ellipse((X2-R-G_PosX)*G_Zoom, (Y+20-R-G_PosY)*G_Zoom, (X2+R-G_PosX)*G_Zoom, (Y+20+R-G_PosY)*G_Zoom)
    ),
    ((I-N-1) mod 10 =:= 9 -> % Column
      X := X+2*wagon_size
    ), 
    (I=:=Finish ->
      color_text(_, rgb(0, 0, 0))
    ), 
    fail.

best_transfer_station(Best, Color, Dif, Last, I, P, Jump, Jump0):-
  Where := abs(I-Last) mod 10,
  best_dif(Jump, Where, Color2, Dif2),
  (Dif2 < Dif ->
    Best := Last,
    Color := Color2,
    Dif := Dif2
  ),
  Last2 := Last + P*Jump,
  NextJump := 1 + Jump mod 4,
  (P*Last2 < P*I, NextJump =\= Jump0 ->
    best_transfer_station(Best, Color, Dif, Last2, I, P, NextJump, Jump0)
  ).

% one
best_dif(2, 1, 1, 9).
best_dif(3, 1, 1, 7).
best_dif(3, 2, 2, 8).
best_dif(4, 1, 1, 4).
best_dif(4, 2, 2, 5).
best_dif(4, 3, 1, 4).
% two
best_dif(1, 2, 2, 1).
best_dif(2, 3, 3, 2).
best_dif(2, 4, 4, 5).
best_dif(3, 4, 4, 3).
best_dif(3, 5, 4, 3).
best_dif(3, 6, 1, 7).
% three
best_dif(4, 6, 1, 4).
best_dif(1, 4, 4, 6).
best_dif(1, 5, 2, 1).
best_dif(2, 6, 1, 9).
best_dif(2, 7, 3, 2).
best_dif(2, 8, 3, 2).
% four
best_dif(3, 9, 2, 8).
best_dif(4, 8, 3, 7).
best_dif(4, 9, 2, 5).
best_dif(1, 7, 3, 3).
best_dif(1, 8, 3, 3).
best_dif(1, 9, 2, 1).

more_variants(Brush, Brushes):-
  (     Brush=:=3 -> (wagon_time(arrive_line(2))>wagon_time(arrive_line(3))-> Brushes=[3, 1] else Brushes=[1, 3])
  else (Brush=:=5 -> (wagon_time(arrive_line(1))>wagon_time(arrive_line(0))-> Brushes=[2, 4] else Brushes=[4, 2])
  else (Brush=:=7 -> (wagon_time(arrive_line(2))>wagon_time(arrive_line(0))-> Brushes=[3, 4] else Brushes=[4, 3])
  else (Brush=:=10 ->
    smaller(Smaller, 0, 1),
    smaller(Smaller2, Smaller, 2),
    smaller(Smaller3, Smaller2, 3),
    final_brush(Smaller3, Brushes)
  else (Brush>4 ->
    convert_brush(Brush, NewBrush), Brushes=[NewBrush]
  else
    Brushes=[Brush]
  ))))).

draw_ellipse(X, Y, R, [Brush|Tail]):-
  make_brush(Brush),
  ellipse((X+R-G_PosX)*G_Zoom, (Y+R-G_PosY)*G_Zoom, (X-R-G_PosX)*G_Zoom, (Y-R-G_PosY)*G_Zoom),
  Y1:=Y+60,
  R1:=R+10,
  draw_ellipse(X, Y1, R1, Tail).
draw_ellipse(_, _, _, []).

draw_mark(X, Y, R, [Brush|Tail]):-
  make_brush(Brush),
  fill_polygon((X-R-G_PosX)*G_Zoom, (Y+25+R-G_PosY)*G_Zoom, (X+R-G_PosX)*G_Zoom, (Y+25-G_PosY)*G_Zoom, (X-R-G_PosX)*G_Zoom, (Y+25-R-G_PosY)*G_Zoom),
  X1:=X+60,
  R1:=R+10,
  draw_mark(X1, Y, R1, Tail).
draw_mark(_, _, _, []).

remove_el(El, [], []).
remove_el(El,[El|T],T):- !.
remove_el(El,[H|L],[H|T]):-
  remove_el(El,L,T).

final_brush(0, [3, 2, 1, 4]).
final_brush(1, [1, 4, 3, 2]).
final_brush(2, [2, 1, 4, 3]).
final_brush(3, [4, 3, 2, 1]).

smaller(Smaller, I, J):- (wagon_time(arrive_line(I))>wagon_time(arrive_line(J))-> Smaller=J else Smaller=I).

make_list(N, Station):-
  PosY := 2550,
  font(G_Zoom*90,G_Zoom*225,_),
  Finish := finish_station(1),
  for(I, 0, 3),
    X := Station+(I-2)*wagon_size,
    make_jump(I, Jump),
    make_list2(N, N, Finish, Jump, Jump, X, PosY).
make_list(_, _).

make_list2(N0, N, Finish, Jump0, Jump, X, Y):-
  N2 := N+Jump,
  N2 =< Finish,
  R:= 100,
  Brush:= (N2-N0) mod 10,
  Jump2 := 1 + Jump mod 4,
  Y2 := Y+300,
  station(_, N2, _, _, Text, Text2),
  (     Brush=:=3 -> (wagon_time(arrive_line(2))>wagon_time(arrive_line(3))-> Arrive= 1 else Arrive= 3)
  else (Brush=:=5 -> (wagon_time(arrive_line(1))>wagon_time(arrive_line(0))-> Arrive= 4 else Arrive= 2)
  else (Brush=:=7 -> (wagon_time(arrive_line(2))>wagon_time(arrive_line(0))-> Arrive= 4 else Arrive= 3)
  else (Brush=:=0 ->
    smaller(Smaller, 0, 1),
    smaller(Smaller2, Smaller, 2),
    smaller(Smaller3, Smaller2, 3),
    make_jump(Smaller3, Arrive)
  else
    Arrive=Jump0
  )))),
  (Arrive=\=Jump0 -> color_text(_, rgb(160, 160, 255)) ),
  text_out( N2+". "+Text+" "+Text2+" ", pos((X+200-G_PosX)*G_Zoom-5, (Y2-G_PosY)*G_Zoom-10)),
  (Arrive=\=Jump0->
    direction(Jump0, Arrive, Dir),
    make_brush(Arrive),
    fill_polygon((X-Dir*R-G_PosX)*G_Zoom, (Y2+25+R-G_PosY)*G_Zoom, (X+Dir*R-G_PosX)*G_Zoom, (Y2+25-G_PosY)*G_Zoom, (X-Dir*R-G_PosX)*G_Zoom, (Y2+25-R-G_PosY)*G_Zoom),
    color_text(_, rgb(0, 0, 0))
  ),
  make_list2(N0, N2, Finish, Jump0, Jump2, X, Y2).

first_will_come(First):-
  Time := max_integer,
  for(I, 0, 3),
    Time > wagon_time(arrive_line(I)),
    Time := wagon_time(arrive_line(I)),
    make_jump(I, Jump),
    First := Jump,
  fail.
first_will_come(_).    

direction(1, _, -1).
direction(2, 1,  1).
direction(2, 3,  1).
direction(2, 4, -1).
direction(3, 1,  1).
direction(3, 2, -1).
direction(3, 4, -1).
direction(4, _,  1).

make_jump(0, 4).
make_jump(1, 2).
make_jump(2, 3).
make_jump(3, 1).

init_wagon_arrive:-
  for(I, 0, 12),
  wagon_arrive(I):= -1,
  fail.
init_wagon_arrive.

find_wagon_arrive(Last, Station, Posoka):-
  Last =\= -1,
  Posoka*(Station+Posoka*4000-wagonX(Last)) > 0,
  (Posoka*(Station-Posoka*4000-wagonX(Last)) > 0; wStop(Last)=:=0 ->
    wagon_arrive(wLine(Last)):= Last
  ),
  Last := find_head(wPrevious(Last)),
  find_wagon_arrive(Last, Station, Posoka).

calc_wagon_time(Station, Posoka):-
  StartPoint := finish_station_pos(-1*Posoka) - Posoka*9000,
  for(I, 0, 9),
  (wagon_arrive(I)=:= -1 ->
    (G_Stop =:= 0 ->
      Periods := (((I-line(1-Posoka)-1) mod 10)+1),
      wagon_time(I):= Periods*G_time_period + abs(Station - StartPoint)/G_Statistic_averSpeed
    else
      wagon_time(I):= max_integer
    )
  else (wFlags(wagon_arrive(I))/\4=\=0, Posoka*(Station - Posoka*4000 - wagonX(wagon_arrive(I))) < 0 ->
    wagon_time(I):= 0
  else
    wagon_time(I):= abs(Station + Posoka*4000 - wagonX(wagon_arrive(I)))/G_Statistic_averSpeed
  )),
  fail.
calc_wagon_time(_, _).

make_line(0, 5).
make_line(1, 0).
make_line(2, 2).
make_line(3, 9).

calc_arrive_line(N, Posoka):-
  for(I, 0, 3),
    make_line(I, Line),
    arrive_line(I):=(Line + Posoka*(finish_station(-1*Posoka) - N)) mod 10,
  fail.
calc_arrive_line(_, _).

find_first(TrainSize, ArriveLine, TrainSize2, ArriveLine2):-
  TrainSize := G_TrainSize,
  TrainSize2 := G_TrainSize,
  ArriveLine := 3,
  ArriveLine2 := 3,
  StartTime := max_integer,
  StartTime2 := max_integer,
  for(I, 0, 3),
    (wagon_time(arrive_line(I)) < StartTime ->
      TrainSize2 := TrainSize,
      ArriveLine2 := ArriveLine,
      StartTime2 := StartTime,
      make_improve(TrainSize, ArriveLine, StartTime, I)
    else (wagon_time(arrive_line(I)) < StartTime2 ->
      make_improve(TrainSize2, ArriveLine2, StartTime2, I)
    )),
  fail.
find_first(_, _, _, _).

make_improve(TrainSize, ArriveLine, StartTime, I):-
  ArriveLine := I,
  StartTime := wagon_time(arrive_line(I)),
  (wagon_arrive(arrive_line(I)) =\= -1 ->
    TrainSize := wFlags(wagon_arrive(arrive_line(I))) // 0x1000
  ).

map_list(0, "Map").
map_list(1, "List").

draw_data(Station, Flag):-
  PosY := 2350,
  X := Station-2000-2*wagon_size,
  (Flag =:= 0->
    (G_The_map_in_the_wagon =:= 0 ->
      map_list(G_map_list, Text),
      text_out(Text, pos((X-G_PosX)*G_Zoom-5, (PosY-G_PosY)*G_Zoom-10))
    ),
    draw_N(Station)
  ),
  (Flag =:= 1; G_The_map_in_the_wagon =:= 0 ->
    (G_Unexpected_Delay =:= 1 ->
      text_out("Un.D.", pos((X-G_PosX)*G_Zoom-5, (PosY+400-G_PosY)*G_Zoom-10))
    ),
    (G_Accident =:= 1 ->
      text_out("Accident", pos((X-G_PosX)*G_Zoom-5, (PosY+800-G_PosY)*G_Zoom-10))
    ),
    (G_More_Info2 =:= 1 ->
      text_out(trains_await(0)+" <-> "+trains_await(2), pos((X-G_PosX)*G_Zoom-5, (PosY+1600-G_PosY)*G_Zoom-10)),
      text_out(first(0,5)+", "+first(0,6)+" <-> "+first(2,5)+", "+first(2,6), pos((X-G_PosX)*G_Zoom-5, (PosY+2000-G_PosY)*G_Zoom-10)),
      %text_out(first(0,1)+", "+first(0,2)+" & "+first(0,3)+", "+first(0,4)+" & "+first(0,7)+", "+first(0,0)+" <-> "+first(2,0)+", "+first(2,7)+" & "+first(2,3)+", "+first(2,4)+" & "+first(2,1)+", "+first(2,2), pos((X-G_PosX)*G_Zoom-5, (PosY+2400-G_PosY)*G_Zoom-10)),
      text_out(hex_string(busy(0))+" <-> "+hex_string(busy(2)), pos((X-G_PosX)*G_Zoom-5, (PosY+2800-G_PosY)*G_Zoom-10))
    )
  ).

draw_N(Station):-
  PosY := 2300,
  for(I, 0, 3),
    X := Station+(I-2)*wagon_size-200,
    make_jump(I, Jump),
    text_out(Jump, pos((X+2050-G_PosX)*G_Zoom-5, (PosY-G_PosY)*G_Zoom-10)),
    text_out(string_from_ASCII(first_ASCII("a")+I), pos((X+400-G_PosX)*G_Zoom-5, (PosY-G_PosY-420)*G_Zoom-10)),
  fail.
draw_N(_).

draw_when(Station):-
  PosY := 2450,
  font(G_Zoom*110,G_Zoom*275,_),
  color_text(_, rgb(255, 255, 0)),
  color_text_back(_, rgb(0, 0, 127)), 
  for(I, 0, 3),
    X := Station+(I-2)*wagon_size,
    choose_brush(I),
    round_rect((X-G_PosX+100)*G_Zoom, (PosY-G_PosY-200)*G_Zoom, (X-G_PosX+wagon_size-100)*G_Zoom, (PosY-G_PosY-100)*G_Zoom, 100*G_Zoom, 100*G_Zoom),
    Time := wagon_time(arrive_line(I)),
    Text := (Time =:= max_integer -> " No more " else " After "+round(Time/600)+" min "),
    text_out(Text, pos((X+400-G_PosX)*G_Zoom-5, (PosY-G_PosY)*G_Zoom-10)),
    % text_out(" After: "+Time//10+" s ", pos((X-G_PosX)*G_Zoom-5, (1950-G_PosY)*G_Zoom-10)),
    % text_out(" At: "+(G_Time+Time)//10+" ", pos((X-G_PosX)*G_Zoom-5, (1950-G_PosY)*G_Zoom-10)),
    fail.
draw_when(_):-
  font(10,25,_),
  color_text(_, rgb(0, 0, 0)), 
  color_text_back(_, rgb(255, 255, 255)).

choose_brush(0):- brush( rgb(255, 0, 0)).
choose_brush(1):- brush( rgb(0, 0, 255)).
choose_brush(2):- brush( rgb(255, 255, 0)).
choose_brush(3):- brush( rgb(0, 255, 0)).
choose_brush(4):- brush( rgb(255, 255, 255)).

make_station(Posoka, PosX, PosY, ZoomX, ZoomY, Variant):-
  init_wagon_arrive,
  for(N, finish_station(-1*Posoka), finish_station(Posoka), step(Posoka)),
  visible_station(N, Station, _, 5000, Variant),
  pen(0, 0),
  Add := Posoka*(Variant=big-> 400 else 0),
  (Posoka =:= 1 ->
    brush(rgb(100,150,150)),
    X1 := Station-5000+40,
    X2 := Station+5000-40,
    Y1 := 1250-1000,
    Y2 := 1250+1000,
    round_rect((X1-PosX)*ZoomX, (Y1-PosY)*ZoomY, (X2-PosX)*ZoomX, (Y2-PosY)*ZoomY, 1000*ZoomX, 1000*ZoomY)
  ),
  Last := first(1-Posoka, 7),
  (Last =\= -1 ->
    Last := find_head(Last),
    (find_wagon_arrive(Last, Station, Posoka); true)
  ),
  calc_wagon_time(Station, Posoka),
  calc_arrive_line(N, Posoka),
  find_first(TrainSize, ArriveLine, TrainSize2, ArriveLine2),
  pen(0, 0),
  for(I, 0, 3),
    (TrainSize =:= 4 ->
      Brush := ArriveLine
    else (TrainSize =:= 2 ->
      (I//2 =:= ArriveLine//2 ->
        Brush := ArriveLine
      else (TrainSize2 =\= 1 ->
        Brush := ArriveLine2
      else % small problem when 2, 1, 4 
        Brush := I
      ))
    else
      (I =:= ArriveLine ->
        Brush := I
      else (TrainSize2 =:= 4 ->
        Brush := ArriveLine2
      else (TrainSize2 =:= 2, I//2 =:= ArriveLine2//2 ->
        Brush := ArriveLine2
      else
        Brush := I
      )))
    )),
    (G_Try_the_standard_scheme =:= 0 ->
      choose_brush(Brush)
    else
      choose_brush(4)
    ),
    X1 := Station-Posoka*(4000-I*wagon_size)+Add,
    X2 := X1+Posoka*(wagon_size)-2*Add,
    Y1 := 1250+Posoka*500,
    Y2 := 1250+Posoka*900,
    rect((X1-PosX)*ZoomX, (Y1-PosY)*ZoomY, (X2-PosX)*ZoomX, (Y2-PosY)*ZoomY),
    (Variant=big->
      draw_pie((X1-PosX+Add)*ZoomX+Posoka, (Y1-PosY+Add)*ZoomY+Posoka, (X1-PosX-Add)*ZoomX+Posoka, (Y1-PosY-Add)*ZoomY+Posoka,
               (X1-PosX-Add)*ZoomX,        (Y1-PosY)*ZoomY,            (X1-PosX)*ZoomX,            (Y1-PosY+Add)*ZoomY),
      draw_pie((X2-PosX-Add)*ZoomX-Posoka, (Y1-PosY+Add)*ZoomY+Posoka, (X2-PosX+Add)*ZoomX-Posoka, (Y1-PosY-Add)*ZoomY+Posoka,
               (X2-PosX)*ZoomX,            (Y1-PosY+Add)*ZoomY,        (X2-PosX+Add)*ZoomX,        (Y1-PosY)*ZoomY),
      put_arrows(I, Brush, X1, Posoka)
    ),
  fail.

put_arrows(Peron, Brush, X1, 1):-
  G_Zoom>0.08,
  G_More_Info =:= 1,
  Y := 1250+700,
  for(N, 0, 3),
    (Brush =:= N ->
      (Brush < 2 ->
        pen(10*G_Zoom, rgb(255, 255, 255))
      else
        pen(10*G_Zoom, 0)
      )
    ),
    choose_brush(N),
    X := 400*N + X1,
    ArriveWagon := wagon_arrive(arrive_line(N)),
    TrainSize := (ArriveWagon =\= -1 -> wFlags(ArriveWagon) // 0x1000 else G_TrainSize),
    (TrainSize =:= 4; TrainSize =:= 2, N//2 =:= Peron//2; N =:= Peron ->
      fill_polygon( % Up
 (X-G_PosX-25)*G_Zoom, (Y-G_PosY+100)*G_Zoom,
 (X-G_PosX-25)*G_Zoom, (Y-G_PosY-25)*G_Zoom,
 (X-G_PosX-75)*G_Zoom, (Y-G_PosY-25)*G_Zoom,
 (X-G_PosX)*G_Zoom, (Y-G_PosY-100)*G_Zoom,
 (X-G_PosX+75)*G_Zoom, (Y-G_PosY-25)*G_Zoom,
 (X-G_PosX+25)*G_Zoom, (Y-G_PosY-25)*G_Zoom,
 (X-G_PosX+25)*G_Zoom, (Y-G_PosY+100)*G_Zoom)
    else (Peron>N ->
      fill_polygon( % Left
 (X-G_PosX+100)*G_Zoom,(Y-G_PosY-25)*G_Zoom,
 (X-G_PosX-25)*G_Zoom, (Y-G_PosY-25)*G_Zoom,
 (X-G_PosX-25)*G_Zoom, (Y-G_PosY-75)*G_Zoom,
 (X-G_PosX-100)*G_Zoom, (Y-G_PosY)*G_Zoom,
 (X-G_PosX-25)*G_Zoom, (Y-G_PosY+75)*G_Zoom,
 (X-G_PosX-25)*G_Zoom, (Y-G_PosY+25)*G_Zoom,
 (X-G_PosX+100)*G_Zoom,(Y-G_PosY+25)*G_Zoom)
    else
      fill_polygon( % Right
 (X-G_PosX-100)*G_Zoom,(Y-G_PosY-25)*G_Zoom,
 (X-G_PosX+25)*G_Zoom, (Y-G_PosY-25)*G_Zoom,
 (X-G_PosX+25)*G_Zoom, (Y-G_PosY-75)*G_Zoom,
 (X-G_PosX+100)*G_Zoom, (Y-G_PosY)*G_Zoom,
 (X-G_PosX+25)*G_Zoom, (Y-G_PosY+75)*G_Zoom,
 (X-G_PosX+25)*G_Zoom, (Y-G_PosY+25)*G_Zoom,
 (X-G_PosX-100)*G_Zoom,(Y-G_PosY+25)*G_Zoom)
    )),
    (Brush =:= N ->
      pen(0, 0)
    ).

find_wagon(Xp, Yp):-
  for(I, 0, G_WagonNum-1),
    wagonX(I) - 1000 < Xp, Xp < wagonX(I) + 1000,
    wagonY(I) - 150 < Yp, Yp < wagonY(I) + 150,
    !,
    G_The_Wagon := I,
    G_PosX1 := G_PosX - wagonX(I),
    G_PosX2 := 0,
    modify_menu(G_Menu_Show, 5, _, "Follow the wagon with number " + I ),
    (G_Follow_the_wagon =:= 0 ->
      follow_the_wagon
    ),
    (G_The_map_in_the_wagon =:= 0 ->
      menu_the_map_in_the_wagon(press)
    ),
    update_window(_).

find_wagon(_, _).
