statistic(LR, I):-
  (wTime(I) =\= -1 ->
    G_Statistic_Course:=G_Statistic_Course+1,
    G_Statistic_Time := G_Statistic_Time + G_Time - wTime(I),
    (statistic(LR)=:= -1 -> statistic(LR):= G_Time), % first train
    statistic(LR+1):= G_Time, % last train
    Mod is 20,
    (G_Statistic_Course mod Mod =:= 0 ->
      Length := finish_station_pos(1) - finish_station_pos(-1) + 2*8000+ G_TrainSize*wagon_size, % end_map+500000
      Wagons_in_use := G_Wagons_in_use - first(0,5) - first(0,6) - first(2,5) - first(2,6),
      Aver := G_Statistic_Time/Mod,
      G_Statistic_averSpeed := Length/Aver,
      calc_period(Period, Mod),
      Wait_on_station := 3.98, % 0.5 + (6*4.5 + 1*1 + 1*2 + 2*2.4)/10 
      WithTransfer := 2.5,     % 0.5 + 1 + (4*0 + 3*1 + 2*3 + 1*3)/10
      Trains_p_m :=600/Period, nl,
      MaxSpeed := (G_Statistic_Max_Speed =:= 0 -> "unknown." else pp(0.36*G_Statistic_Max_Speed)+" km/h."),
      StationStay := (G_Statistic_Stations =:= 0 -> "unknown." else pp(G_Statistic_Station_Stay/G_Statistic_Stations/10)+" s."),
      write("     Statistic "+G_Statistic_Course//Mod, in_red), write(". (Length "+Length/100000+" km, "+Wagons_in_use+" wagons in use, Traffic "+G_Traffic+")"), nl, nl,
      write("Period between trains", in_blue), write(" = "), write(Period//10, in_red), write(" s, it is given to be "+ G_time_period//10+" s."), nl,
      write("                Speed", in_blue), write(" = "), write(pp(0.36*G_Statistic_averSpeed), in_red), write(" km/h,            Max Speed = "+MaxSpeed), nl,
      write("              Dencity", in_blue), write(" = "), write(pp(G_TrainSize*Trains_p_m), in_red), write(" wagons/min,       "+pp(Trains_p_m)+" trains/min."), nl,
      write("      Wait on station", in_blue), write(" = "),
      (G_Try_the_standard_scheme =:= 0 -> 
        write(Wait_on_station*Period//10, in_red), write(" s, with transfer it is "+WithTransfer*Period//10+" s, ev. station stay is "+StationStay)
      else
        write(0.5*Period//10, in_red), write(" s, ev. station stay is "+StationStay)
      ),
      nl, nl,
      init_statistic2
    )
  ).

R is pp(X) :- R := round(100*X)/100.

init_statistic :-
  G_Statistic_Course:=0,
  init_statistic2,
  for(I, 0, G_WagonNum-1),
    wTime(I) := -1,
  fail.
init_statistic.

init_statistic2 :-
  G_Statistic_Time := 0,
  G_Statistic_Stations := 0,
  G_Statistic_Station_Stay := 0,
  G_Statistic_Max_Speed := 0,
  statistic(0) := -1,
  statistic(2) := -1.

calc_period(Period, Mod):-
  (statistic(0) =:= -1 ->
    Period := (statistic(3)-statistic(2))/(Mod-1)
  else (statistic(2) =:= -1 ->
    Period := (statistic(1)-statistic(0))/(Mod-1)
  else 
    Period := (statistic(1)-statistic(0)+statistic(3)-statistic(2))/(Mod-2)
  )).

R is finish_station_pos(Posoka):-
  N := finish_station(Posoka),
  station(yes, N, StationX, _, _, _),
  R := StationX.

calc_Distanse(Distanse, Limit, I):-
  Distanse := 0.8*(abs(wagonX(wPrevious(I))-wagonX(I))-wagon_size-G_ExtraDistance), % 0.8 coef.
   % -(abs(wSpeed(I)-wSpeed(wPrevious(I)))>40; wAcceleration(wPrevious(I)) =:= -1*wPosoka(I)-> 800 else 0),  % 40, 800 coef.
  Limit := max(0, (wSpeed(I)**2)/G_Crazy_Speed-(wSpeed(wPrevious(I))**2)/2).

end_of_slowdown(I):-
  wFlags(I):=wFlags(I)/\0xffdf, % 32
  NextSpeed := wSpeed(I) + wPosoka(I),
  (2*wPosoka(I)*(wStopAt(I)-wagonX(I)-NextSpeed)<NextSpeed**2->
    wFlags(I):=(wFlags(I)\/64)/\0xffdf, % 32
    move_train2(I, -1*wPosoka(I), 0)
  else
    (G_Energy_Saving =:= 1 ->
      TargetSpeed := min(max_speed, integer(sqrt(0.5*(wSpeed(I)**2/2+wPosoka(I)*(wStopAt(I)-wagonX(I))))))
    else
      TargetSpeed := max_speed
    ),
    (abs(wSpeed(I)) < TargetSpeed-> 
      move_train2(I, wPosoka(I), wPosoka(I)*TargetSpeed)
    else
      move_train2(I, 0, 0)
    )
  ).

move_train(I):-
  (G_Energy_Saving =:= 1 ->
    TargetSpeed := min(max_speed, integer(sqrt(0.5*(wSpeed(I)**2/2+wPosoka(I)*(wStopAt(I)-wagonX(I)))))) % 0.5=2/4
  else
    TargetSpeed := max_speed
  ),
  move_train2(I, wPosoka(I), wPosoka(I)*TargetSpeed).

move_train2(I, A, S):-
  wAcceleration(I) := A,
  wTargetSpeed(I) := S,
  (wNext(I)=\= -1, wFlags(wNext(I))/\1=\=0->
    move_train2(wNext(I), A, S)
  ).

in_curve(I, X1, Y1, Sign, R):-
  metro_arc(X1, Y1, Sign, X2, Y2, R, Semaphore),
  Sign * wPosoka(I) * sign(wagonX(I)) =:= -1,
  (wPosoka(I)*X1<wPosoka(I)*X2->
    (abs(X1-wagonX(I))<600, abs(Y1-wagonY(I))<200, Semaphore\=no->
      (semaphore(Semaphore)=:=0 -> fail)
    else
      wagonY(I)>1010, wagonY(I)<1490
    ),
    wPosoka(I)*wagonX(I)>=wPosoka(I)*X1,
    wPosoka(I)*wagonX(I)<wPosoka(I)*X2
  else
    wagonY(I)>1010, wagonY(I)<1490,
    wPosoka(I)*wagonX(I)>=wPosoka(I)*X2,
    wPosoka(I)*wagonX(I)<wPosoka(I)*X1,
    Sign := -1*Sign
  ).

init_wagon(I):-
  wJump(I) > 0, % for second wagon
  wJump(I) := 1 + wJump(I) mod 4,
  wStop(I) := wJump(I),
  train_flag(I, 0),
  stop_at_pos(I, wStop(I)),
  move_train(I).

train_flag(I, Flag):-
  (wFlags(I) /\ 1 =:= 0 ->
    wFlags(I):= wFlags(I) /\ 0x7000 + Flag
  else
    wFlags(I):= 1 + Flag
  ),
  Next := wNext(I),
  (Next =\= -1, wFlags(Next) /\ 1 =\= 0 ->
    train_flag(Next, Flag)
  ).

make_ready_out(LR, B):-
  Wagon := first(LR, B+2),
  busy(LR) := (B =:= 1 -> (busy(LR) /\ 0xff) \/ 0x100 else (busy(LR) /\ 0xf0f) \/ 0x10),
  wFlags(Wagon) := (wFlags(Wagon) /\ 0x7000) + 8,
  wJump(Wagon) := -1*B,
  wPosoka(Wagon) := -1*wPosoka(Wagon),
  StationX := finish_station_pos(wPosoka(Wagon)),
  wStopAt(Wagon):= StationX + wPosoka(Wagon)*(4.5*wagon_size + 8000 + G_ExtraDistance),
  move_train(Wagon),
  P := first(LR, B),
  (P =\= -1 ->
    wFlags(P) := 0,
    wPosoka(P) := -1*wPosoka(P),
    wStopAt(P):= StationX + wPosoka(P)*((4.5+wFlags(Wagon)//0x1000)*wagon_size + 8000 + G_ExtraDistance),
    move_train(P)
  ).

make_ready_in(LR, B):-
  (first(LR, B+4) >= G_TrainSize,
   busy(LR) /\ (B =:= 1 -> 0x700 else 0x70) =:= 0 ->
    % then
    first(LR, B+4) ::= first(LR, B+4) - G_TrainSize,
    Wagon := first(LR, B),
    wFlags(Wagon) := 0x1000*G_TrainSize,
    make_ready_in2(LR, B, Wagon),
    train_size_next(P, Wagon, G_TrainSize),
    first(LR, B) ::= P,
    (P =\= -1 ->
      wJump(P) := -1*B,
      wFlags(P) := 0,
      wNext(wPrevious(P)) := -1,
      wPrevious(P) := -1,
      StationX := finish_station_pos(-1*wPosoka(P)),
      wStopAt(P):= StationX - wPosoka(P)*(4.5*wagon_size + 8000 + G_ExtraDistance),
      move_train(P)
    )
  ).

make_ready_in2(LR, B, Wagon):-
  busy(LR) := busy(LR) \/ (B =:= 1 -> 0x300 else 0x30),
  wFlags(Wagon) := wFlags(Wagon) + 24, % 8,16
  StationX := finish_station_pos(-1*wPosoka(Wagon)),
  wStopAt(Wagon):= StationX - wPosoka(Wagon)*(wagon_size//2 + 8000),
  move_train(Wagon).

make_ready_8(I):- % /\8
  (wJump(I)>0 ->
    LR := 1+wPosoka(I),
    B := true_value(busy(LR)/\2 =:= 0) + 1,
    statistic(LR, I),
    upside_down(LR, I, Tail),
    wPrevious(Tail):= -1,
    wNext(I):= -1,
    (wFlags(I) /\ 0x300 =\= 0 ->
      wFlags(Tail) := (wFlags(I) /\ 0x7300),
      (not(traffic_jam(LR, 50000)) ->
        make_ready_in(LR, 3-B)
      )
    else
      wFlags(Tail) := (wFlags(I) /\ 0x7000) + 2
    ),
    Flag := (B =:= 1 -> 0x400 else 0x40),
    (busy(LR) /\ Flag =\= 0 ->
      (wFlags(I) /\ 0x300 =:= 0 ->
        busy(LR) := busy(LR) xor (Flag + Flag//2)
      ),
      P := first(LR, B+2),
      (P =\= -1 ->
        wFlags(Tail) := wFlags(Tail) + wFlags(P)/\0x7000,
        glue(P, I)
      )
    ),
    (I =\= Tail -> wFlags(I) := 1),
    wJump(I) := 0,
    wJump(Tail) := -1*(B+2),
    first(LR, B+2) ::= Tail,
    busy(LR) := busy(LR) /\ (B =:= 1 -> 0xefd else 0xfeb) % (2,0x100 or 4,0x10)
  else
    B := -1*wJump(I),
    (wFlags(I) /\ 16 =\= 0 -> % in
      abs(wStopAt(I)-wagonX(I))<5,
      % then
      LR := 1-wPosoka(I),
      wFlags(I) := (wFlags(I) /\ 0x7000) + 2,
      wJump(I) := -2-B, % -3 or -4
      first(LR, B+2) ::= I
    else % out
      LR := 1+wPosoka(I),
      wPosoka(I) := -1*wPosoka(I),
      first(LR, B+4) ::= first(LR, B+4) + wFlags(I)//0x1000,
      wFlags(I) := 0,
      P := first(LR, B),
      first(LR, B) ::= I,
      (P =\= -1 ->
        wPosoka(P) := -1*wPosoka(P),
        glue(P, I)
      ),
      first(LR, B+2) ::= -1
    ),
    busy(LR) := busy(LR) /\ (B =:= 1 -> 0xeff else 0xfef) % (0x100 or 0x10)
  ).

glue(P, I):-
  wFlags(P) := 1,
  wJump(P) := 0,
  Last := find_last(I),
  wNext(Last):=P,
  wPrevious(P):=Last.

make_ready_2(I):- % /\2
  (wJump(I)>0 ->
    wPrevious(I) =:= -1,
    StationX := finish_station_pos(wPosoka(I)),
    abs(StationX-wagonX(I)) < 25000,
    % then
    LR := 1+wPosoka(I),
    TrainSize := wFlags(I) // 0x1000,
    (busy(LR) /\ 0x440 =\= 0 ->
      B := true_value(busy(LR)/\0x400 =:= 0)+1,
      P := first(LR, B+2),
      ABC    := (wFlags(P)/\0x700) // 0x100,
      P_Size := wFlags(P) // 0x1000,
      (ABC+P_Size<G_TrainSize; TrainSize =:= 4; TrainSize =:= 2, ABC =\= 2 ->
        make_ready_out(LR, B),
        fail
      else
        (B =:= 1 ->
          busy(LR) /\ 0x707 =:= 0x400,
          busy(LR) := busy(LR) + 0x102
        else
          busy(LR) /\ 0x76 =:= 0x40,
          busy(LR) := busy(LR) + 0x14
        ),
        Compose := ABC - TrainSize
      )
    else
      (busy(LR) /\ 0x707 =:= 0 -> % 0x700, 1, 2, 4
        B := 1
      else (busy(LR) /\ 0x76 =:= 0 -> % 0x70, 2, 4
        B := 2
      else
        fail
      )),
      (TrainSize < G_TrainSize ->
        (B =:= 1, first(LR, 6)< G_TrainSize ->
          busy(LR) /\ 0x76 =:= 0,
          B := 2
        ),
        composition(TrainSize, G_TrainSize, Compose),
        busy(LR) := (B =:= 1 -> (busy(LR) /\ 0xff) \/ 0x502 else (busy(LR) /\ 0xf0f) \/ 0x54)
      else
        Compose := 0,
        busy(LR) := busy(LR) \/ (B =:= 1 -> 0x302 else 0x34)
      )
    ),
    semaphore(LR+1) := B mod 2,
    semaphore(LR) := 0,
    wFlags(I) := (wFlags(I) /\ 0x7000) + 0x100*Compose + 8,
    wStopAt(I):= wStopAt(I) + wPosoka(I)*(3000+(TrainSize+Compose)*wagon_size),
    end_of_slowdown(I)
  else
    LR := 1-wPosoka(I),
    (busy(LR) /\ 0x770 =:= 0x220, traffic_jam(LR, 15000) -> % both ready and jam
      B := (first(LR, 5) < first(LR, 6) -> 1 else 2),
      make_ready_out(LR, B)
    else
      B := -1*wJump(I)-2, % 1 or 2
      (B =:= 1 -> busy(LR) /\ 0x703 =:= 0x200 else busy(LR) /\ 0x77 =:= 0x20), % (1,2,0x100 or 1,2,4,0x10)
      % then
      start_train(LR, B),
      (not(traffic_jam(LR, 50000)) ->
        make_ready_in(LR, 3-B)
      )
    )
  ).

composition(1, 4, 3).
composition(2, 4, 2).
composition(1, 2, 1).

traffic_jam(LR, Distance):-
  I := first(2-LR, 0),
  it_is_close(I, Distance),
  (trains_await(LR) > 0 ->
    J := wNext(I),
    it_is_close(J, Distance)
  ).

it_is_close(I, Distance):-
  I =\= -1,
  StationX := finish_station_pos(wPosoka(I)),
  abs(StationX-wagonX(I)) < Distance.

it_will_stop_close(Last, Distance):-
  Last =\= -1,
  StationX := finish_station_pos(-1*wPosoka(Last)),
  abs(StationX-wStopAt(find_head(Last))) < Distance.

upside_down(LR, Last, Tail):-
  wPosoka(Last):= -1*wPosoka(Last),
  I := wNext(Last),
  (I =:= -1; wFlags(I) /\ 1 =:= 0 ->
    first(2-LR, 0) ::= I,
    (I =:= -1 ->
      first(2-LR, 7) ::= -1
    else
      wPrevious(I):= -1
    ),
    Tail := Last
  else
    upside_down(LR, I, Tail),
    wPrevious(Last):=I,
    wNext(I):=Last
  ).

train_size_next(P, I, Size):-
  P := wNext(I),
  (P =\= -1, Size > 1 ->
    train_size_next(P, P, Size-1)
  ).

start_train(LR, B):-
  Train := first(LR, B+2),
  Train =\= -1,
  TrainSize := wFlags(Train) // 0x1000,
  (TrainSize < G_TrainSize ->
    make_ready_out(LR, B)
  else
    real_start(LR, B, Train, TrainSize)
  ).

real_start(LR, B, Train, TrainSize):-
  trains_await(LR) > 0,
  Last := first(LR, 7),
  not(it_will_stop_close(Last, 4000)),
  (B =:= 1 -> 
    busy(LR) /\ 0x70 =\= 0x20 % B is not ready
  else
    not(
      busy(LR) /\ 0x700 =:= 0, % A is empty
      I := first(2-LR, 0),
      I =\= -1,
      wFlags(I)/\6 =\= 0, % 2,4
      wFlags(I) // 0x1000 =:= G_TrainSize,
      StationX := finish_station_pos(wPosoka(I)),
      abs(StationX-wagonX(I)) < 25000
    )
  ),
  % then
  (TrainSize > G_TrainSize ->
    train_size_next(P, Train, G_TrainSize),
    first(LR, B+2) ::= P,
    wFlags(P) := 0x1000 * (TrainSize - G_TrainSize),
    (TrainSize - G_TrainSize < G_TrainSize ->
      wNext(wPrevious(P)) := -1,
      wPrevious(P) := -1,
      make_ready_out(LR, B)
    else
      wJump(P) := -1*B,
      make_ready_in2(LR, B, P)
    ),
    wFlags(Train):= 0x1000 * G_TrainSize
  else
    first(LR, B+2) ::= -1,
    wFlags(Train):= 0x1000 * G_TrainSize + 16
  ),
  real_start2(LR, B, Train).

real_start2(LR, B, Train):-
  busy(LR) := busy(LR) \/ (B =:= 1 -> 0x301 else 0x32),
  trains_await(LR) := trains_await(LR) - 1,
  wTime(Train) := G_Time,
  semaphore(LR+1) := 0,
  semaphore(LR) := (B =:= 1 -> 0 else 1),
  wPrevious(Train) := first(LR, 7), % last
  (first(LR, 7) =\= -1 ->
    wNext(first(LR, 7)) := Train
  ),
  (first(LR, 0) =:= -1 ->
    first(LR, 0) ::= Train
  ),
  first(LR, 7) ::= find_last(Train),
  Line := (line(LR) + 1) mod 10,
  line(LR) := Line,
  wLine(Train) := Line,
  next_stop(Line, Jump, Stop),
  wJump(Train) := Jump,
  wStop(Train) := Stop,
  stop_at_pos(Train, Stop),
  move_train(Train).

pos_point( _, 3, 4).
pos_point( Jump, Platform, 2) :- Platform := (Jump mod 2 =:= 0 -> 3 else 1).
pos_point( 4, 3, 1). % 1
pos_point( 2, 2, 1). % 3
pos_point( 1, 1, 1). % 2
pos_point( 3, 0, 1). % 4

stop_at_pos(Wagon, Stop):-
  (between_stations(Wagon, N)->
    stop_at_pos2(Wagon, Stop-1, N)
  else
    StationX := finish_station_pos(wPosoka(Wagon)),
    wStopAt(Wagon):= 4000*wPosoka(Wagon)+StationX,
    wFlags(Wagon):= (wFlags(Wagon) /\ 0x7000) + 2
  ).
  % write("Wagon="+Wagon+" StopAt="+wStopAt(Wagon)), nl.

stop_at_pos2(Wagon, Stop, N):-
  station(yes, N, StationX, _, _, _),
  (G_Try_the_standard_scheme =:= 1 ->
    wJump(Wagon) := 1,
    wStop(Wagon) := 1,
    wStopAt(Wagon):= (3*wagon_size-3000)*wPosoka(Wagon)+StationX
  else (Stop=:=0->
    Jump := wJump(Wagon),
    TrainSize := wFlags(Wagon)//0x1000,
    pos_point(Jump, Platform, TrainSize),
    wStopAt(Wagon):= (Platform*wagon_size-3000)*wPosoka(Wagon)+StationX
  else (next_station(Wagon, N, Next)->
    stop_at_pos2(Wagon, Stop-1, Next)
  else
    wStopAt(Wagon):= 4000*wPosoka(Wagon)+StationX,
    wFlags(Wagon):= (wFlags(Wagon) /\ 0x7000) + 2
  ))).

between_stations(Wagon, N):-
  P := wPosoka(Wagon),
  station(yes, N, Station, _, _, _),
  P*wagonX(Wagon) =< P*Station-4000,
  (previous_station(Wagon, N, Previous)->
    station(yes, Previous, Station2, _, _, _),
    P*wagonX(Wagon) > P*Station2-4000
  ).

before_station(Wagon, N):-
  (abs(wagonX(Wagon)-wStopAt(Wagon))<8000 ->
    station(yes, N, Station, _, _, _),
    abs(Station-wStopAt(Wagon))<4000
  else
    between_stations(Wagon, N)
  ).

R is find_last(Train) :-
  (wNext(Train) =:= -1; wFlags(wNext(Train))/\1 =:= 0 ->
    R := Train
  else
    R := find_last(wNext(Train))
  ).

R is find_head(Train) :-
  (wFlags(Train) /\ 1 =:= 0 ->
    R := Train
  else
    R := find_head(wPrevious(Train))
  ).

previous_station(Wagon, N, Previous):-
  N =\= finish_station(-1*wPosoka(Wagon)),
  Previous := N-wPosoka(Wagon).

next_station(Wagon, N, Next):-
  N =\= finish_station(wPosoka(Wagon)),
  Next := N+wPosoka(Wagon).
